-- $Source: /user/cp_source/ObjectAda/rts/common/strings_characters/ada.strings.wide_maps.wide_constants.dat,v $
-- $Revision: 1.2 $ $Date: 1996/11/07 04:26:26 $ $Author: bm $
--        Copyright (C) 1995 by Intermetrics, Inc.

with Ada.Characters.Latin_1;

package Ada.Strings.Wide_Maps.Wide_Constants is
    pragma Suppress( Elaboration_Check );
    pragma Preelaborate (Wide_Constants);

    Control_Set           : constant Wide_Character_Set;
    Graphic_Set           : constant Wide_Character_Set;
    Letter_Set            : constant Wide_Character_Set;
    Lower_Set             : constant Wide_Character_Set;
    Upper_Set             : constant Wide_Character_Set;
    Basic_Set             : constant Wide_Character_Set;
    Decimal_Digit_Set     : constant Wide_Character_Set;
    Hexadecimal_Digit_Set : constant Wide_Character_Set;
    Alphanumeric_Set      : constant Wide_Character_Set;
    Special_Graphic_Set   : constant Wide_Character_Set;
    ISO_646_Set           : constant Wide_Character_Set;
    Character_Set         : constant Wide_Character_Set;

    Lower_Case_Map        : constant Wide_Character_Mapping;
    --  Maps to lower case for letters, else identity

    Upper_Case_Map        : constant Wide_Character_Mapping;
    --  Maps to upper case for letters, else identity

    Basic_Map             : constant Wide_Character_Mapping;
    --  Maps to basic letter for letters, else identity

private

    use Ada.Characters.Latin_1;

    Control_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Wide_Character'Pos(Wide_Character'First),
            01 => Character'Pos(US) + 1,
            02 => Character'Pos(DEL),
            03 => Character'Pos(APC) + 1
            );
    Control_Set : constant Wide_Character_Set := Control_Set_Array'access;

    Graphic_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos(Space),
            01 => Character'Pos(Tilde) + 1,
            02 => Character'Pos(Character'Last) + 1
            );
    Graphic_Set : constant Wide_Character_Set := Graphic_Set_Array'access;

    Letter_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos('A'),
            01 => Character'Pos('Z') + 1,
            02 => Character'Pos('a'),
            03 => Character'Pos('z') + 1,
            04 => Character'Pos(UC_A_Grave),
            05 => Character'Pos(UC_O_Diaeresis) + 1,
            06 => Character'Pos(UC_O_Oblique_Stroke),
            07 => Character'Pos(LC_O_Diaeresis) + 1,
            08 => Character'Pos(LC_O_Oblique_Stroke),
            09 => Character'Pos(LC_Y_Diaeresis) + 1
            );
    Letter_Set : constant Wide_Character_Set := Letter_Set_Array'access;

    Lower_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos('a'),
            01 => Character'Pos('z') + 1,
            02 => Character'Pos(LC_German_Sharp_S),
            03 => Character'Pos(LC_O_Diaeresis) + 1,
            04 => Character'Pos(LC_O_Oblique_Stroke),
            05 => Character'Pos(LC_Y_Diaeresis) + 1
            );
    Lower_Set : constant Wide_Character_Set := Lower_Set_Array'access;

    Upper_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos('A'),
            01 => Character'Pos('Z') + 1,
            02 => Character'Pos(UC_A_Grave),
            03 => Character'Pos(UC_O_Diaeresis) + 1,
            04 => Character'Pos(UC_O_Oblique_Stroke),
            05 => Character'Pos(UC_Icelandic_Thorn) + 1
            );
    Upper_Set : constant Wide_Character_Set := Upper_Set_Array'access;

    Basic_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos('A'),
            01 => Character'Pos('Z') + 1,
            02 => Character'Pos('a'),
            03 => Character'Pos('z') + 1,
            04 => Character'Pos(UC_AE_Diphthong),
            05 => Character'Pos(UC_AE_Diphthong) + 1,
            06 => Character'Pos(LC_AE_Diphthong),
            07 => Character'Pos(LC_AE_Diphthong) + 1,
            08 => Character'Pos(LC_German_Sharp_S),
            09 => Character'Pos(LC_German_Sharp_S) + 1,
            10 => Character'Pos(UC_Icelandic_Thorn),
            11 => Character'Pos(UC_Icelandic_Thorn) + 1,
            12 => Character'Pos(LC_Icelandic_Thorn),
            13 => Character'Pos(LC_Icelandic_Thorn) + 1,
            14 => Character'Pos(UC_Icelandic_Eth),
            15 => Character'Pos(UC_Icelandic_Eth) + 1,
            16 => Character'Pos(LC_Icelandic_Eth),
            17 => Character'Pos(LC_Icelandic_Eth) + 1
            );
    Basic_Set : constant Wide_Character_Set := Basic_Set_Array'access;

    Decimal_Digit_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos('0'),
            01 => Character'Pos('9') + 1
            );
    Decimal_Digit_Set : constant Wide_Character_Set :=
        Decimal_Digit_Set_Array'access;

    Hexadecimal_Digit_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos('0'),
            01 => Character'Pos('9') + 1,
            02 => Character'Pos('A'),
            03 => Character'Pos('F') + 1,
            04 => Character'Pos('a'),
            05 => Character'Pos('f') + 1
            );
    Hexadecimal_Digit_Set : constant Wide_Character_Set :=
        Hexadecimal_Digit_Set_Array'access;

    Alphanumeric_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos('0'),
            01 => Character'Pos('9') + 1,
            02 => Character'Pos('A'),
            03 => Character'Pos('Z') + 1,
            04 => Character'Pos('a'),
            05 => Character'Pos('z') + 1,
            06 => Character'Pos(UC_A_Grave),
            07 => Character'Pos(UC_O_Diaeresis) + 1,
            08 => Character'Pos(UC_O_Oblique_Stroke),
            09 => Character'Pos(LC_O_Diaeresis) + 1,
            10 => Character'Pos(LC_O_Oblique_Stroke),
            11 => Character'Pos(LC_Y_Diaeresis) + 1
            );
    Alphanumeric_Set : constant Wide_Character_Set :=
        Alphanumeric_Set_Array'access;

    Special_Graphic_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Wide_Character'Pos(Wide_Space),
            01 => Character'Pos(Solidus) + 1,
            02 => Character'Pos(Colon),
            03 => Character'Pos(Commercial_At) + 1,
            04 => Character'Pos(Left_Square_Bracket),
            05 => Character'Pos(Grave) + 1,
            06 => Character'Pos(Left_Curly_Bracket),
            07 => Character'Pos(Tilde) + 1,
            08 => Character'Pos(No_Break_Space),
            09 => Character'Pos(Inverted_Question) + 1,
            10 => Character'Pos(Multiplication_Sign),
            11 => Character'Pos(Multiplication_Sign) + 1,
            12 => Character'Pos(Division_Sign),
            13 => Character'Pos(Division_Sign) + 1
            );
    Special_Graphic_Set : constant Wide_Character_Set :=
        Special_Graphic_Set_Array'access;

    ISO_646_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos(NUL),
            01 => Character'Pos(DEL) + 1
            );
    ISO_646_Set : constant Wide_Character_Set := ISO_646_Set_Array'access;

    Character_Set_Array : aliased Wide_Character_Set_Array := (
            00 => Character'Pos(NUL),
            01 => Character'Pos(Character'Last) + 1
            );
    Character_Set : constant Wide_Character_Set := Character_Set_Array'access;

    Lower_Case_Map_From_Array : aliased Wide_Character_Sequence :=
            "ABCDEFGHIJKLMNOPQRSTUVWXYZ"                                  &
            Wide_Character'Val(Character'Pos(UC_A_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_A_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_A_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_A_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_A_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_A_Ring))                  &
            Wide_Character'Val(Character'Pos(UC_AE_Diphthong))            &
            Wide_Character'Val(Character'Pos(UC_C_Cedilla))               &
            Wide_Character'Val(Character'Pos(UC_E_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_E_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_E_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_E_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_I_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_I_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_I_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_I_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_Icelandic_Eth))           &
            Wide_Character'Val(Character'Pos(UC_N_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_O_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_O_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_O_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_O_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_O_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_O_Oblique_Stroke))        &
            Wide_Character'Val(Character'Pos(UC_U_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_U_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_U_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_U_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_Y_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_Icelandic_Thorn));

    Lower_Case_Map_To_Array : aliased Wide_Character_Sequence :=
           "abcdefghijklmnopqrstuvwxyz"                                   &
            Wide_Character'Val(Character'Pos(LC_A_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_A_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_A_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_A_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_A_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_A_Ring))                  &
            Wide_Character'Val(Character'Pos(LC_AE_Diphthong))            &
            Wide_Character'Val(Character'Pos(LC_C_Cedilla))               &
            Wide_Character'Val(Character'Pos(LC_E_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_E_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_E_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_E_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_I_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_I_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_I_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_I_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_Icelandic_Eth))           &
            Wide_Character'Val(Character'Pos(LC_N_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_O_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_O_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_O_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_O_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_O_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_O_Oblique_Stroke))        &
            Wide_Character'Val(Character'Pos(LC_U_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_U_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_U_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_U_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_Y_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_Icelandic_Thorn));

    Lower_Case_Map : constant Wide_Character_Mapping := (
       From => Lower_Case_Map_From_Array'access,
       To   => Lower_Case_Map_To_Array'access);

    Upper_Case_Map_From_Array : aliased Wide_Character_Sequence :=
            "abcdefghijklmnopqrstuvwxyz"                                  &
            Wide_Character'Val(Character'Pos(LC_A_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_A_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_A_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_A_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_A_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_A_Ring))                  &
            Wide_Character'Val(Character'Pos(LC_AE_Diphthong))            &
            Wide_Character'Val(Character'Pos(LC_C_Cedilla))               &
            Wide_Character'Val(Character'Pos(LC_E_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_E_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_E_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_E_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_I_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_I_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_I_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_I_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_Icelandic_Eth))           &
            Wide_Character'Val(Character'Pos(LC_N_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_O_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_O_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_O_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_O_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_O_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_O_Oblique_Stroke))        &
            Wide_Character'Val(Character'Pos(LC_U_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_U_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_U_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_U_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_Y_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_Icelandic_Thorn));

    Upper_Case_Map_To_Array : aliased Wide_Character_Sequence :=
            "ABCDEFGHIJKLMNOPQRSTUVWXYZ"                                  &
            Wide_Character'Val(Character'Pos(UC_A_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_A_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_A_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_A_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_A_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_A_Ring))                  &
            Wide_Character'Val(Character'Pos(UC_AE_Diphthong))            &
            Wide_Character'Val(Character'Pos(UC_C_Cedilla))               &
            Wide_Character'Val(Character'Pos(UC_E_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_E_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_E_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_E_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_I_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_I_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_I_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_I_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_Icelandic_Eth))           &
            Wide_Character'Val(Character'Pos(UC_N_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_O_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_O_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_O_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_O_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_O_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_O_Oblique_Stroke))        &
            Wide_Character'Val(Character'Pos(UC_U_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_U_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_U_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_U_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_Y_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_Icelandic_Thorn));

    Upper_Case_Map : constant Wide_Character_Mapping := (
       From => Upper_Case_Map_From_Array'access,
       To   => Upper_Case_Map_To_Array'access);

    Basic_Map_From_Array : aliased Wide_Character_Sequence :=
            Wide_Character'Val(Character'Pos(UC_A_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_A_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_A_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_A_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_A_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_A_Ring))                  &
            Wide_Character'Val(Character'Pos(UC_C_Cedilla))               &
            Wide_Character'Val(Character'Pos(UC_E_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_E_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_E_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_E_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_I_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_I_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_I_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_I_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_N_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_O_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_O_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_O_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_O_Tilde))                 &
            Wide_Character'Val(Character'Pos(UC_O_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_O_Oblique_Stroke))        &
            Wide_Character'Val(Character'Pos(UC_U_Grave))                 &
            Wide_Character'Val(Character'Pos(UC_U_Acute))                 &
            Wide_Character'Val(Character'Pos(UC_U_Circumflex))            &
            Wide_Character'Val(Character'Pos(UC_U_Diaeresis))             &
            Wide_Character'Val(Character'Pos(UC_Y_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_A_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_A_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_A_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_A_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_A_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_A_Ring))                  &
            Wide_Character'Val(Character'Pos(LC_C_Cedilla))               &
            Wide_Character'Val(Character'Pos(LC_E_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_E_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_E_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_E_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_I_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_I_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_I_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_I_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_N_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_O_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_O_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_O_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_O_Tilde))                 &
            Wide_Character'Val(Character'Pos(LC_O_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_O_Oblique_Stroke))        &
            Wide_Character'Val(Character'Pos(LC_U_Grave))                 &
            Wide_Character'Val(Character'Pos(LC_U_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_U_Circumflex))            &
            Wide_Character'Val(Character'Pos(LC_U_Diaeresis))             &
            Wide_Character'Val(Character'Pos(LC_Y_Acute))                 &
            Wide_Character'Val(Character'Pos(LC_Y_Diaeresis));

    Basic_Map_To_Array : aliased Wide_Character_Sequence :=
            'A'            &              -- UC_A_Grave
            'A'            &              -- UC_A_Acute
            'A'            &              -- UC_A_Circumflex
            'A'            &              -- UC_A_Tilde
            'A'            &              -- UC_A_Diaeresis
            'A'            &              -- UC_A_Ring
            'C'            &              -- UC_C_Cedilla
            'E'            &              -- UC_E_Grave
            'E'            &              -- UC_E_Acute
            'E'            &              -- UC_E_Circumflex
            'E'            &              -- UC_E_Diaeresis
            'I'            &              -- UC_I_Grave
            'I'            &              -- UC_I_Acute
            'I'            &              -- UC_I_Circumflex
            'I'            &              -- UC_I_Diaeresis
            'N'            &              -- UC_N_Tilde
            'O'            &              -- UC_O_Grave
            'O'            &              -- UC_O_Acute
            'O'            &              -- UC_O_Circumflex
            'O'            &              -- UC_O_Tilde
            'O'            &              -- UC_O_Diaeresis
            'O'            &              -- UC_O_Oblique_Stroke
            'U'            &              -- UC_U_Grave
            'U'            &              -- UC_U_Acute
            'U'            &              -- UC_U_Circumflex
            'U'            &              -- UC_U_Diaeresis
            'Y'            &              -- UC_Y_Acute
            'a'            &              -- LC_A_Grave
            'a'            &              -- LC_A_Acute
            'a'            &              -- LC_A_Circumflex
            'a'            &              -- LC_A_Tilde
            'a'            &              -- LC_A_Diaeresis
            'a'            &              -- LC_A_Ring
            'c'            &              -- LC_C_Cedilla
            'e'            &              -- LC_E_Grave
            'e'            &              -- LC_E_Acute
            'e'            &              -- LC_E_Circumflex
            'e'            &              -- LC_E_Diaeresis
            'i'            &              -- LC_I_Grave
            'i'            &              -- LC_I_Acute
            'i'            &              -- LC_I_Circumflex
            'i'            &              -- LC_I_Diaeresis
            'n'            &              -- LC_N_Tilde
            'o'            &              -- LC_O_Grave
            'o'            &              -- LC_O_Acute
            'o'            &              -- LC_O_Circumflex
            'o'            &              -- LC_O_Tilde
            'o'            &              -- LC_O_Diaeresis
            'o'            &              -- LC_O_Oblique_Stroke
            'u'            &              -- LC_U_Grave
            'u'            &              -- LC_U_Acute
            'u'            &              -- LC_U_Circumflex
            'u'            &              -- LC_U_Diaeresis
            'y'            &              -- LC_Y_Acute
            'y';                          -- LC_Y_Diaeresis

    Basic_Map : constant Wide_Character_Mapping := (
       From => Basic_Map_From_Array'access,
       To   => Basic_Map_To_Array'access);

end Ada.Strings.Wide_Maps.Wide_Constants;
