-- $Source: /user/cp_source/ObjectAda/rts/common/tasking/ada.task_identification.spc,v $ 
-- $Revision: 1.1 $ $Date: 1996/02/26 20:47:29 $ $Author: peignot $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

with System.RTS.Tasking_Types_Pkg;

pragma ada_child;
package Ada.Task_Identification is 

    pragma Suppress( Elaboration_Check );

    package RTT renames System.RTS.Tasking_Types_Pkg;
    
    type Task_ID is private;

    -- Implicitly declared: 
    --   function "="(Left, Right : Task_ID) return Boolean;

    Null_Task_ID : constant Task_ID;
    
    function Image( T : Task_ID ) return String;
    
    function Current_Task return Task_ID;
    
    procedure Abort_Task( T : in out Task_ID );
    
    function Is_Terminated( T : Task_ID ) return Boolean;
    
    function Is_Callable( T : Task_ID ) return Boolean;
    
private

    type Task_ID is new RTT.Task_Obj_Header;

    Null_Task_ID : constant Task_ID := 
    	    	    	    	Task_ID( RTT.Null_Task_Obj_Header );  

end Ada.Task_Identification;
