-- $Source: /user/cp_source/ObjectAda/rts/nt/system.rts.tcb.ads,v $
-- $Revision: 1.1 $ $Date: 2000/10/20 23:58:34 $ $Author: curt $
with SYSTEM;
--@IAwith System.Rts.Types;
--@IAwith System.RTS.Tgt_INTEGERS;
--@IAuse System.Rts.Types;
with System.Rts.TCB_TDEP;

package SYSTEM.RTS.TCB is
   pragma Suppress( Elaboration_Check );
   pragma Preelaborate( SYSTEM.RTS.TCB );
 
   subtype TCB_RECORD is SYSTEM.RTS.TCB_TDEP.TCB_RECORD;
     
   type REF_TCB is access all TCB_RECORD;
   
   function CURR_TCB return REF_TCB;
   
   function ENVIRONMENT_TCB return REF_TCB;
--@IA   function ENVIRONMENT_TCB return DATA_ADDRESS;

   -- Allocate TCB from the heap and return a reference to it.  Must be called
   -- by the thread creating this TCB. Copy the display of the current task to
   -- the display in this TCB.
   function ALLOCATE_TCB return REF_TCB;

   -- Initialize a TCB.  Must be called by the thread which own this TCB. Sets
   -- up all TCB fields. Initializes FS segment pointers, TCB pointer at bottom
   -- of stack, sets exception handler hooks, etc.
   -- Note that calls to CURR_TCB are not valid until INITIALIZE_TCB is called.
   procedure INITIALIZE_TCB (TCB                : in REF_TCB;
                             THREAD_POINTER     : in SYSTEM.ADDRESS;
                             SAVED_INTEGER_DATA : in SYSTEM.ADDRESS);

   procedure Restore_Object (SAVED_INTEGER_DATA	: in SYSTEM.ADDRESS;
   			     IS_ENVTCB		: in INTEGER );


   pragma Import (C, environment_tcb, "rts_env_tcb");
   pragma Import (Intrinsic, curr_tcb, "*CURR_TCB");
   pragma Import (C, Allocate_TCB, "rts_allocate_tcb");
   pragma Import (C, Initialize_TCB, "rts_initialize_tcb");
   pragma Import (C, Restore_Object, "rts_restore_object");

end SYSTEM.RTS.TCB;
