-- $Source: /user/cp_source/ObjectAda/rts/nt/system.rts.tcb_tdep.ads,v $
-- $Revision: 1.1 $ $Date: 2000/10/20 23:58:35 $ $Author: curt $

with SYSTEM;

package SYSTEM.RTS.TCB_TDEP is
   pragma Suppress( Elaboration_Check );
   pragma Preelaborate( System.Rts.Tcb_Tdep );

   type BYTE is mod 2**8;
   type BYTE_STRING is array (NATURAL range <>) of BYTE;
   type ADDRESS_ARRAY is array (NATURAL range <>) of SYSTEM.ADDRESS;

-- Defined in TCB.INC
   EM_Stack_Slop: constant Natural;
   pragma Import(C, EM_Stack_Slop, "aonix_em_stack_slop");

-- Must match TCB.INC
   type TCB_RECORD is record
      HIGHWATER_MARK     : SYSTEM.ADDRESS;  -- for SS
      LAST_CHUNK         : SYSTEM.ADDRESS;  -- for SS
      THREAD_POINTER     : SYSTEM.ADDRESS;
      TCB_STACK          : SYSTEM.ADDRESS;  -- offset 16#0C#
      EXTRA_A1           : SYSTEM.ADDRESS;
      EXTRA_A2           : SYSTEM.ADDRESS;
      EXTRA_A3           : SYSTEM.ADDRESS;
      TCB_INITIAL_FP     : SYSTEM.ADDRESS;
      TCB_SAVED_STACK    : SYSTEM.ADDRESS;  -- offset 16#20#
      TCB_IN_EM          : BOOLEAN;         
      IS_EXTENDABLE      : BOOLEAN;         -- for SS
      EXTRA_B1           : BOOLEAN;         -- for later use
      EXTRA_B2           : BOOLEAN;         -- for later use
      EXTRA_A4           : SYSTEM.ADDRESS;  -- for later use
      EXTRA_A5           : SYSTEM.ADDRESS;  -- for later use
      TCB_DISPLAY        : ADDRESS_ARRAY (0..63); -- offset 16#30#
   end RECORD;

end SYSTEM.RTS.TCB_TDEP;
