-- $Source: /user/cp_source/ObjectAda/rts/nt/system.rts.tgt.ada83_support.ads,v $
-- $Revision: 1.1 $ $Date: 2000/10/20 23:58:35 $ $Author: curt $

package System.RTS.TGT.Ada83_Support is

  -- This package provides exception information support
  -- for Ada83 programs through an Ada83 compatible interface.


  function Last_Exception_Name return String;

  -- Return the name of the last exception raised in this task. Return 
  -- the empty string if no exceptions have been raised.


  function Last_Exception_Information return String;

  -- Return a traceback of the last exception raised in this task. Return 
  -- the empty string if no exceptions have been raised.
  --
  -- The string contains:
  --    The name of the exception
  --    A list of locations through which the exception was propagated
  --    The location where the exception was handled
  --
  -- Each name and location in the string is separated by carriage-return
  -- and line-feed control characters.
  --
  -- The exception propagation list contains an implementation-defined
  -- number of locations, currently 8. The first location is that where
  -- the exception was raised.
  --
  -- Each location is displayed in one of two ways. If a symbolic location
  -- can be determined then the line number, subprogram name, and source 
  -- file name corresponding to that location are provided. This will be 
  -- the case for Ada and most C code. If a symbolic location cannot be 
  -- determined then code address of the location in hexadecimal is provided.


  -- Limitations:
  -- Exception locations are displayed in the symbolic form only for 
  -- subprograms in an executable file. Exception locations for
  -- subprograms in DLL's are displayed in the numeric form.

end System.RTS.TGT.Ada83_Support;
