-- $Source: /user/cp_source/ObjectAda/rts/common/kernel/system.rts.tgt.kernel.dat,v $ 
-- $Revision: 1.4 $ $Date: 2001/02/01 23:30:18 $ $Author: shancher $ 
--        Copyright (C) 1995 by Intermetrics, Inc.   

package System.RTS.TGT.Kernel is

    -- This is the root of the Kernel hierarchy.
    -- We define several generally-useful things here.

    pragma Pure(System.RTS.TGT.Kernel);

    subtype Kernel_Priority is Integer range
      System.Any_Priority'First-1 .. System.Any_Priority'Last;
    -- Note that the value of Kernel_Priority'First is used to implement
    -- the "Hold" function.  It is defined as System.Any_Priority'First-1
    -- and hence is below the priority of any executing task.

    subtype Non_Interrupt_Priority is Kernel_Priority
      range Kernel_Priority'First..Priority'Last;

    RTS_Ceiling_Priority: constant Kernel_Priority := Any_Priority'Last;
        -- This is used as the ceiling priority for most protected
        -- objects that are used internally by the RTS.  It is
        -- normally Priority'Last, but on some systems, it could be
        -- an interrupt-level priority, in order to allow more
        -- operations at interrupt level.

end System.RTS.TGT.Kernel;
