--  CMS REPLACEMENT HISTORY, Element WIN32-WINSOCK2.ADS
--  *4    13-JUL-2005 16:06:08 FRK "FR#00002959: Fehler bei WSASocket korrigiert"
--  *3    13-JUN-2001 12:51:09 GAU "F#110031: null -> System.Null_Address"
--  *2    23-MAR-2000 14:11:25 GAU "Correct constant values."
--  *1    30-JUL-1999 17:50:29 GAU ""
--  CMS REPLACEMENT HISTORY, Element WIN32-WINSOCK2.ADS
-- Author: James Winters, Patrick Gautschi
-- Based on Revision: 1.02 (14/06/99) of James Winters
-- Description : A binding to the winsock 2 DLL for use in Windows 32 environment
-- All functions are the Ascii Versions, there is no need to link in a win32 binding
-- You need to link with ws32_2.lib and ensure that he winsock 2 DLL is loaded.
-- Based on the Intermetrics Winsock Binding

with Win32.Windef;
with Win32.Winnt;
with Interfaces.C;
--use Interfaces.C;

package Win32.Winsock2 is

--@if OA
    pragma Linker_Options ("-defaultlib:ws2_32");
--@endif
--@if GNAT
--`    pragma Linker_Options ("-lws2_32");
--@endif

    subtype u_long is Win32.ULONG;                          -- winsock2.h:39

    use type interfaces.c.char_array;
    function "not"(uOperand : Interfaces.C.unsigned)
                return Interfaces.C.unsigned
                renames Interfaces.C."not";

    --Socket Array
    FD_SETSIZE                 : constant := 64;            -- winsock2.h:
    --IOCtl
    IOCPARM_MASK               : constant := 16#7f#;        -- winsock2.h:178
    IOC_VOID                   : constant := 16#20000000#;  -- winsock2.h:179
    IOC_OUT                    : constant := 16#40000000#;  -- winsock2.h:180
    IOC_IN                     : constant := 16#80000000#;  -- winsock2.h:181
    IOC_INOUT                  : constant := 16#c0000000#;  -- winsock2.h:182
    --IP Protocol
    IPPROTO_IP                 : constant := 0;             -- winsock2.h:252
    IPPROTO_ICMP               : constant := 1;             -- winsock2.h:253
    IPPROTO_IGMP               : constant := 2;             -- winsock2.h:253
    IPPROTO_GGP                : constant := 3;             -- winsock2.h:254
    IPPROTO_TCP                : constant := 6;             -- winsock2.h:255
    IPPROTO_PUP                : constant := 12;            -- winsock2.h:256
    IPPROTO_UDP                : constant := 17;            -- winsock2.h:257
    IPPROTO_IDP                : constant := 22;            -- winsock2.h:258
    IPPROTO_ND                 : constant := 77;            -- winsock2.h:259
    IPPROTO_RAW                : constant := 255;           -- winsock2.h:260
    IPPROTO_MAX                : constant := 256;           -- winsock2.h:261
    --Port/socket Standard functions
    IPPORT_ECHO                : constant := 7;             -- winsock2.h:268
    IPPORT_DISCARD             : constant := 9;             -- winsock2.h:269
    IPPORT_SYSTAT              : constant := 11;            -- winsock2.h:270
    IPPORT_DAYTIME             : constant := 13;            -- winsock2.h:271
    IPPORT_NETSTAT             : constant := 15;            -- winsock2.h:272
    IPPORT_FTP                 : constant := 21;            -- winsock2.h:273
    IPPORT_TELNET              : constant := 23;            -- winsock2.h:274
    IPPORT_SMTP                : constant := 25;            -- winsock2.h:275
    IPPORT_TIMESERVER          : constant := 37;            -- winsock2.h:276
    IPPORT_NAMESERVER          : constant := 42;            -- winsock2.h:277
    IPPORT_WHOIS               : constant := 43;            -- winsock2.h:278
    IPPORT_MTP                 : constant := 57;            -- winsock2.h:279
    --Port/socket host specific
    IPPORT_TFTP                : constant := 69;            -- winsock2.h:284
    IPPORT_RJE                 : constant := 77;            -- winsock2.h:285
    IPPORT_FINGER              : constant := 79;            -- winsock2.h:286
    IPPORT_TTYLINK             : constant := 87;            -- winsock2.h:287
    IPPORT_SUPDUP              : constant := 95;            -- winsock2.h:288
    --Unix TCP Sockets
    IPPORT_EXECSERVER          : constant := 512;           -- winsock2.h:293
    IPPORT_LOGINSERVER         : constant := 513;           -- winsock2.h:294
    IPPORT_CMDSERVER           : constant := 514;           -- winsock2.h:295
    IPPORT_EFSSERVER           : constant := 520;           -- winsock2.h:296
    --Unix UDP Sockets
    IPPORT_BIFFUDP             : constant := 512;           -- winsock2.h:301
    IPPORT_WHOSERVER           : constant := 513;           -- winsock2.h:302
    IPPORT_ROUTESERVER         : constant := 520;           -- winsock2.h:303
    --Privileged processes
    IPPORT_RESERVED            : constant := 1024;          -- winsock2.h:306
    --Link numbers
    IMPLINK_IP                 : constant := 155;           -- winsock2.h:313
    IMPLINK_LOWEXPER           : constant := 156;           -- winsock2.h:314
    IMPLINK_HIGHEXPER          : constant := 158;           -- winsock2.h:315

    --Definitions of bits in internet address integers.
    --On subnets, the decomposition of addresses to host and net parts
    --is done according to subnet mask, not the masks here.

    IN_CLASSA_NET              : constant := 16#ff000000#;  -- winsock2.h:348
    IN_CLASSA_NSHIFT           : constant := 24;            -- winsock2.h:349
    IN_CLASSA_HOST             : constant := 16#ffffff#;    -- winsock2.h:350
    IN_CLASSA_MAX              : constant := 128;           -- winsock2.h:351
    IN_CLASSB_NET              : constant := 16#ffff0000#;  -- winsock2.h:354
    IN_CLASSB_NSHIFT           : constant := 16;            -- winsock2.h:355
    IN_CLASSB_HOST             : constant := 16#ffff#;      -- winsock2.h:356
    IN_CLASSB_MAX              : constant := 65536;         -- winsock2.h:357
    IN_CLASSC_NET              : constant := 16#ffffff00#;  -- winsock2.h:360
    IN_CLASSC_NSHIFT           : constant := 8;             -- winsock2.h:361
    IN_CLASSC_HOST             : constant := 16#ff#;        -- winsock2.h:362
    IN_CLASSD_NET              : constant := 16#f0000000#;  -- winsock2.h:364
    IN_CLASSD_NSHIFT           : constant := 28;            -- winsock2.h:365
    IN_CLASSD_HOST             : constant := 16#fffffff#;   -- winsock2.h:366

    INADDR_ANY                 : constant u_long := 16#0#;  -- winsock2.h:370
    INADDR_LOOPBACK            : constant := 16#7f000001#;  -- winsock2.h:371
    INADDR_BROADCAST           : constant u_long := 16#ffffffff#;
                                                            -- winsock2.h:372
    INADDR_NONE                : constant := 16#ffffffff#;  -- winsock2.h:373
    ADDR_ANY                   : constant := INADDR_ANY;    -- winsock2.h:374

    WSADESCRIPTION_LEN         : constant := 256;           -- winsock2.h:387
    WSASYS_STATUS_LEN          : constant := 128;           -- winsock2.h:388
    --Error Messages
    INVALID_SOCKET             : constant := Win32.UINT'Last;
                                                            -- winsock2.h:417
    SOCKET_ERROR               : constant := -1;            -- winsock2.h:418
    --Use in place of family to indicate that parameters fetched from structure
    FROM_PROTOCOL_INFO         : constant := -1;            -- winsock2.h:426
    --types
    SOCK_STREAM                : constant := 1;             -- winsock2.h:431
    SOCK_DGRAM                 : constant := 2;             -- winsock2.h:432
    SOCK_RAW                   : constant := 3;             -- winsock2.h:433
    SOCK_RDM                   : constant := 4;             -- winsock2.h:434
    SOCK_SEQPACKET             : constant := 5;             -- winsock2.h:435
    --Option flags per socket
    SO_DEBUG                   : constant := 16#1#;         -- winsock2.h:440
    SO_ACCEPTCONN              : constant := 16#2#;         -- winsock2.h:441
    SO_REUSEADDR               : constant := 16#4#;         -- winsock2.h:442
    SO_KEEPALIVE               : constant := 16#8#;         -- winsock2.h:443
    SO_DONTROUTE               : constant := 16#10#;        -- winsock2.h:444
    SO_BROADCAST               : constant := 16#20#;        -- winsock2.h:445
    SO_USELOOPBACK             : constant := 16#40#;        -- winsock2.h:446
    SO_LINGER                  : constant := 16#80#;        -- winsock2.h:447
    SO_OOBINLINE               : constant := 16#100#;       -- winsock2.h:448

    SO_DONTLINGER              : constant := not  Win32.UINT'(SO_LINGER);
                                                            -- winsock2.h:450
    SO_EXCLUSIVEADDRUSE        : constant := not  Win32.UINT'(SO_REUSEADDR);
                                                            -- winsock2.h:451
    --Additional options
    SO_SNDBUF                  : constant := 16#1001#;      -- winsock2.h:456
    SO_RCVBUF                  : constant := 16#1002#;      -- winsock2.h:457
    SO_SNDLOWAT                : constant := 16#1003#;      -- winsock2.h:458
    SO_RCVLOWAT                : constant := 16#1004#;      -- winsock2.h:459
    SO_SNDTIMEO                : constant := 16#1005#;      -- winsock2.h:460
    SO_RCVTIMEO                : constant := 16#1006#;      -- winsock2.h:461
    SO_ERROR                   : constant := 16#1007#;      -- winsock2.h:462
    SO_TYPE                    : constant := 16#1008#;      -- winsock2.h:463

    --WinSock 2 extension -- new options

    SO_GROUP_ID                : constant := 16#2001#;      -- ID of a socket group
    SO_GROUP_PRIORITY          : constant := 16#2002#;      -- the relative priority within a group
    SO_MAX_MSG_SIZE            : constant := 16#2003#;      -- maximum message size
    SO_PROTOCOL_INFOA          : constant := 16#2004#;      -- WSAPROTOCOL_INFOA structure
    SO_PROTOCOL_INFOW          : constant := 16#2005#;      -- WSAPROTOCOL_INFOW structure
    SO_PROTOCOL_INFO           : constant := SO_PROTOCOL_INFOA;
    PVD_CONFIG                 : constant := 16#3001#;          -- configuration info for service provider

    --TCP Options
    TCP_NODELAY                : constant := 16#1#;         -- winsock2.h:480

    --Address Family Options, although AF_UNSPEC provided it is RECOMMENDED not to us it
    AF_UNSPEC                  : constant := 0;             -- winsock2.h:498
    AF_UNIX                    : constant := 1;             -- winsock2.h:499
    AF_INET                    : constant := 2;             -- winsock2.h:500
    AF_IMPLINK                 : constant := 3;             -- winsock2.h:501
    AF_PUP                     : constant := 4;             -- winsock2.h:502
    AF_CHAOS                   : constant := 5;             -- winsock2.h:503
    AF_IPX                     : constant := 6;             -- winsock2.h:504
    AF_NS                      : constant := 6;             -- winsock2.h:505
    AF_ISO                     : constant := 7;             -- winsock2.h:506
    AF_OSI                     : constant := 7;             -- winsock2.h:507
    AF_ECMA                    : constant := 8;             -- winsock2.h:508
    AF_DATAKIT                 : constant := 9;             -- winsock2.h:509
    AF_CCITT                   : constant := 10;            -- winsock2.h:510
    AF_SNA                     : constant := 11;            -- winsock2.h:511
    AF_DECnet                  : constant := 12;            -- winsock2.h:512
    AF_DLI                     : constant := 13;            -- winsock2.h:513
    AF_LAT                     : constant := 14;            -- winsock2.h:514
    AF_HYLINK                  : constant := 15;            -- winsock2.h:515
    AF_APPLETALK               : constant := 16;            -- winsock2.h:516
    AF_NETBIOS                 : constant := 17;            -- winsock2.h:517
    AF_VOICEVIEW               : constant := 18;            -- VoiceView
    AF_FIREFOX                 : constant := 19;            -- Protocols from Firefox
    AF_UNKNOWN1                : constant := 20;            -- Somebody is using this!
    AF_BAN                     : constant := 21;            -- Banyan
    AF_ATM                     : constant := 22;            -- Native ATM Services
    AF_INET6                   : constant := 23;            -- Internetwork Version 6
    AF_CLUSTER                 : constant := 24;            -- Microsoft Wolfpack
    AF_12844                   : constant := 25;            -- IEEE 1284.4 WG AF
    AF_IRDA                    : constant := 26;            -- IrDA
    AF_NETDES                  : constant := 28;
    AF_MAX                     : constant := 29;            -- winsock2.h:527
    --Protocol Families
    PF_UNSPEC                  : constant := AF_UNSPEC;
    PF_UNIX                    : constant := AF_UNIX;
    PF_INET                    : constant := AF_INET;
    PF_IMPLINK                 : constant := AF_IMPLINK;
    PF_PUP                     : constant := AF_PUP;
    PF_CHAOS                   : constant := AF_CHAOS;
    PF_NS                      : constant := AF_NS;
    PF_IPX                     : constant := AF_IPX;
    PF_ISO                     : constant := AF_ISO;
    PF_OSI                     : constant := AF_OSI;
    PF_ECMA                    : constant := AF_ECMA;
    PF_DATAKIT                 : constant := AF_DATAKIT;
    PF_CCITT                   : constant := AF_CCITT;
    PF_SNA                     : constant := AF_SNA;
    PF_DECnet                  : constant := AF_DECnet;
    PF_DLI                     : constant := AF_DLI;
    PF_LAT                     : constant := AF_LAT;
    PF_HYLINK                  : constant := AF_HYLINK;
    PF_APPLETALK               : constant := AF_APPLETALK;
    PF_VOICEVIEW               : constant := AF_VOICEVIEW;
    PF_FIREFOX                 : constant := AF_FIREFOX;
    PF_UNKNOWN1                : constant := AF_UNKNOWN1;
    PF_BAN                     : constant := AF_BAN;
    PF_ATM                     : constant := AF_ATM;
    PF_INET6                   : constant := AF_INET6;
    PF_MAX                     : constant := AF_MAX;
    --socket Level
    SOL_SOCKET                 : constant := 16#ffff#;      -- winsock2.h:590
    SOMAXCONN                  : constant := 16#7fffffff#;  -- winsock2.h:595

    MSG_OOB                    : constant := 16#1#;         -- winsock2.h:598
    MSG_PEEK                   : constant := 16#2#;         -- winsock2.h:599
    MSG_DONTROUTE              : constant := 16#4#;         -- winsock2.h:600
    MSG_MAXIOVLEN              : constant := 16;            -- winsock2.h:603
    MSG_PARTIAL                : constant := 16#8000#;      -- winsock2.h:605
    MSG_INTERRUPT              : constant := 16#10#;        -- send/recv in the interrupt context

    MAXGETHOSTSTRUCT           : constant := 1024;          -- winsock2.h:614

    FD_READ_BIT                : constant := 0;             -- winsock2.h:624
    FD_READ                    : constant := 1;             -- winsock2.h:625
    FD_WRITE_BIT               : constant := 1;             -- winsock2.h:626
    FD_WRITE                   : constant := 2;             -- winsock2.h:627
    FD_OOB_BIT                 : constant := 2;             -- winsock2.h:628
    FD_OOB                     : constant := 4;             -- winsock2.h:629
    FD_ACCEPT_BIT              : constant := 3;             -- winsock2.h:630
    FD_ACCEPT                  : constant := 8;             -- winsock2.h:631
    FD_CONNECT_BIT             : constant := 4;             -- winsock2.h:632
    FD_CONNECT                 : constant := 16;            -- winsock2.h:638
    FD_CLOSE_BIT               : constant := 5;             -- winsock2.h:639
    FD_CLOSE                   : constant := 32;            -- winsock2.h:640
    FD_QOS_BIT                 : constant := 6;             -- winsock2.h:641
    FD_QOS                     : constant := 64;            -- winsock2.h:642
    FD_GROUP_QOS_BIT           : constant := 7;             -- winsock2.h:643
    FD_GROUP_QOS               : constant := 128;           -- winsock2.h:644
    FD_ROUTING_INTERFACE_CHANGE_BIT  : constant := 8;       -- winsock2.h:645
    FD_ROUTING_INTERFACE_CHANGE      : constant := 256;     -- winsock2.h:646
    FD_ADDRESS_LIST_CHANGE_BIT       : constant := 9;       -- winsock2.h:647
    FD_ADDRESS_LIST_CHANGE           : constant := 512;     -- winsock2.h:648
    FD_MAX_EVENTS              : constant := 10;            -- winsock2.h:649
    FD_ALL_EVENTS              : constant := 1023;          -- winsock2.h:650

    --error messages
    WSABASEERR                 : constant := 10000;         -- winsock2.h:657
    WSAEINTR                   : constant := 10004;         -- winsock2.h:661
    WSAEBADF                   : constant := 10009;         -- winsock2.h:662
    WSAEACCES                  : constant := 10013;         -- winsock2.h:663
    WSAEFAULT                  : constant := 10014;         -- winsock2.h:664
    WSAEINVAL                  : constant := 10022;         -- winsock2.h:665
    WSAEMFILE                  : constant := 10024;         -- winsock2.h:666
    WSAEWOULDBLOCK             : constant := 10035;         -- winsock2.h:671
    WSAEINPROGRESS             : constant := 10036;         -- winsock2.h:672
    WSAEALREADY                : constant := 10037;         -- winsock2.h:673
    WSAENOTSOCK                : constant := 10038;         -- winsock2.h:674
    WSAEDESTADDRREQ            : constant := 10039;         -- winsock2.h:675
    WSAEMSGSIZE                : constant := 10040;         -- winsock2.h:676
    WSAEPROTOTYPE              : constant := 10041;         -- winsock2.h:677
    WSAENOPROTOOPT             : constant := 10042;         -- winsock2.h:678
    WSAEPROTONOSUPPORT         : constant := 10043;         -- winsock2.h:679
    WSAESOCKTNOSUPPORT         : constant := 10044;         -- winsock2.h:680
    WSAEOPNOTSUPP              : constant := 10045;         -- winsock2.h:681
    WSAEPFNOSUPPORT            : constant := 10046;         -- winsock2.h:682
    WSAEAFNOSUPPORT            : constant := 10047;         -- winsock2.h:683
    WSAEADDRINUSE              : constant := 10048;         -- winsock2.h:684
    WSAEADDRNOTAVAIL           : constant := 10049;         -- winsock2.h:685
    WSAENETDOWN                : constant := 10050;         -- winsock2.h:686
    WSAENETUNREACH             : constant := 10051;         -- winsock2.h:687
    WSAENETRESET               : constant := 10052;         -- winsock2.h:688
    WSAECONNABORTED            : constant := 10053;         -- winsock2.h:689
    WSAECONNRESET              : constant := 10054;         -- winsock2.h:690
    WSAENOBUFS                 : constant := 10055;         -- winsock2.h:691
    WSAEISCONN                 : constant := 10056;         -- winsock2.h:692
    WSAENOTCONN                : constant := 10057;         -- winsock2.h:693
    WSAESHUTDOWN               : constant := 10058;         -- winsock2.h:694
    WSAETOOMANYREFS            : constant := 10059;         -- winsock2.h:695
    WSAETIMEDOUT               : constant := 10060;         -- winsock2.h:696
    WSAECONNREFUSED            : constant := 10061;         -- winsock2.h:697
    WSAELOOP                   : constant := 10062;         -- winsock2.h:698
    WSAENAMETOOLONG            : constant := 10063;         -- winsock2.h:699
    WSAEHOSTDOWN               : constant := 10064;         -- winsock2.h:700
    WSAEHOSTUNREACH            : constant := 10065;         -- winsock2.h:701
    WSAENOTEMPTY               : constant := 10066;         -- winsock2.h:702
    WSAEPROCLIM                : constant := 10067;         -- winsock2.h:703
    WSAEUSERS                  : constant := 10068;         -- winsock2.h:704
    WSAEDQUOT                  : constant := 10069;         -- winsock2.h:705
    WSAESTALE                  : constant := 10070;         -- winsock2.h:706
    WSAEREMOTE                 : constant := 10071;         -- winsock2.h:707
    WSAEDISCON                 : constant := 10101;         -- winsock2.h:717
    WSASYSNOTREADY             : constant := 10091;         -- winsock2.h:714
    WSAVERNOTSUPPORTED         : constant := 10092;         -- winsock2.h:715
    WSANOTINITIALISED          : constant := 10093;         -- winsock2.h:716
    WSAENOMORE                 : constant := 10102;         -- winsock2.h:718
    WSAECANCELLED              : constant := 10103;         -- winsock2.h:719
    WSAEINVALIDPROCTABLE       : constant := 10104;         -- winsock2.h:720
    WSAEINVALIDPROVIDER        : constant := 10105;         -- winsock2.h:721
    WSAEPROVIDERFAILEDINIT     : constant := 10106;         -- winsock2.h:722
    WSASYSCALLFAILURE          : constant := 10107;         -- winsock2.h:723
    WSASERVICE_NOT_FOUND       : constant := 10108;         -- winsock2.h:724
    WSATYPE_NOT_FOUND          : constant := 10109;         -- winsock2.h:725
    WSA_E_NO_MORE              : constant := 10110;         -- winsock2.h:726
    WSA_E_CANCELLED            : constant := 10111;         -- winsock2.h:727
    WSAEREFUSED                : constant := 10112;         -- winsock2.h:728
    WSAHOST_NOT_FOUND          : constant := 11001;         -- winsock2.h:742
    HOST_NOT_FOUND             : constant := 11001;         -- winsock2.h:763
    WSATRY_AGAIN               : constant := 11002;         -- winsock2.h:743
    TRY_AGAIN                  : constant := 11002;         -- winsock2.h:764
    WSANO_RECOVERY             : constant := 11003;         -- winsock2.h:744
    NO_RECOVERY                : constant := 11003;         -- winsock2.h:765
    WSANO_DATA                 : constant := 11004;         -- winsock2.h:745
    NO_DATA                    : constant := 11004;         -- winsock2.h:766
    WSANO_ADDRESS              : constant := 11004;         -- winsock2.h:767
    NO_ADDRESS                 : constant := 11004;         -- winsock2.h:768

    subtype u_char is Win32.UCHAR;                          -- winsock2.h:36
    subtype u_short is Win32.USHORT;                        -- winsock2.h:37
    subtype u_int is Win32.UINT;                            -- winsock2.h:38
    type SOCKET    is  new u_int;                           -- winsock2.h:84

    --QOS related errors

    WSA_QOS_RECEIVERS          : constant := 11005;         -- at least one Reserve has arrived
    WSA_QOS_SENDERS            : constant := 11006;         -- at least one Path has arrived
    WSA_QOS_NO_SENDERS         : constant := 11007;         -- there are no senders
    WSA_QOS_NO_RECEIVERS       : constant := 11008;         -- there are no receivers
    WSA_QOS_REQUEST_CONFIRMED  : constant := 11009;         -- Reserve has been confirmed
    WSA_QOS_ADMISSION_FAILURE  : constant := 11010;         -- error due to lack of resources
    WSA_QOS_POLICY_FAILURE     : constant := 11011;         -- rejected for administrative reasons
    WSA_QOS_BAD_STYLE          : constant := 11012;         -- unknown or conflicting style
    WSA_QOS_BAD_OBJECT         : constant := 11013;         -- problem with some part of the filter
    WSA_QOS_TRAFFIC_CTRL_ERROR : constant := 11014;         -- problem with some part of the flowspec
    WSA_QOS_GENERIC_ERROR      : constant := 11015;         -- general error

    type SOCKET_Array is                                    -- winsock2.h:61
        array(integer range 0..FD_SETSIZE-1)
        of SOCKET;

    type FD_SET;                                            -- winsock2.h:59
    type TIMEVAL;                                           -- winsock2.h:102
    type HOSTENT;                                           -- winsock2.h:158
    type netent;                                            -- winsock2.h:171
    type SERVENT;                                           -- winsock2.h:178
    type PROTOENT;                                          -- winsock2.h:185
    type struct_anonymous1_t;                               -- winsock2.h:270
    type struct_anonymous2_t;                               -- winsock2.h:271
    type union_anonymous3_t;                                -- winsock2.h:273
    type IN_ADDR;                                           -- winsock2.h:268
    type SOCKADDR_IN;                                       -- winsock2.h:318
    type WSADATA;                                           -- winsock2.h:328
    type ip_mreq;                                           -- winsock2.h:357
    type SOCKADDR;                                          -- winsock2.h:473
    type sockproto;                                         -- winsock2.h:482
    type LINGER;                                            -- winsock2.h:515

    type LPWSADATA is access all WSADATA;                   -- winsock2.h:338

    type ac_SOCKADDR_t is access all SOCKADDR;              -- winsock2.h:705
    type PSOCKADDR is access all SOCKADDR;                  -- winsock2.h:830
    subtype LPSOCKADDR is PSOCKADDR;                        -- winsock2.h:831

    type PSOCKADDR_IN is access all SOCKADDR_IN;            -- winsock2.h:834
    subtype LPSOCKADDR_IN is PSOCKADDR_IN;                  -- winsock2.h:835

    type PLINGER is access all LINGER;                      -- winsock2.h:838
    subtype LPLINGER is PLINGER;                            -- winsock2.h:839

    type PIN_ADDR is access all IN_ADDR;                    -- winsock2.h:842
    subtype LPIN_ADDR is PIN_ADDR;                          -- winsock2.h:843

    type PFD_SET is access all FD_SET;                      -- winsock2.h:846
    subtype LPFD_SET is PFD_SET;                            -- winsock2.h:847

    type PHOSTENT is access all HOSTENT;                    -- winsock2.h:850
    subtype LPHOSTENT is PHOSTENT;                          -- winsock2.h:851

    type PSERVENT is access all SERVENT;                    -- winsock2.h:854
    subtype LPSERVENT is PSERVENT;                          -- winsock2.h:855

    type PPROTOENT is access all PROTOENT;                  -- winsock2.h:858
    subtype LPPROTOENT is PPROTOENT;                        -- winsock2.h:859

    type ac_TIMEVAL_t is access all TIMEVAL;           -- winsock2.h:742
    type PTIMEVAL is access all TIMEVAL;                    -- winsock2.h:862
    subtype LPTIMEVAL is PTIMEVAL;                          -- winsock2.h:863

    type FD_SET is                                          -- winsock2.h:59
        record
            fd_count: u_int;                                -- winsock2.h:60
            fd_array: SOCKET_Array;                         -- winsock2.h:61
        end record;

    type TIMEVAL is                                         -- winsock2.h:102
        record
            tv_sec : Win32.LONG;                            -- winsock2.h:103
            tv_usec: Win32.LONG;                            -- winsock2.h:104
        end record;

    type PPCHAR is access all Win32.PSTR;                   -- winsock2.h:160

    type HOSTENT is                                         -- winsock2.h:158
        record
            h_name     : Win32.PSTR;                        -- winsock2.h:159
            h_aliases  : PPCHAR;                            -- winsock2.h:160
            h_addrtype : Win32.SHORT;                       -- winsock2.h:161
            h_length   : Win32.SHORT;                       -- winsock2.h:162
            h_addr_list: PPCHAR;                            -- winsock2.h:163
        end record;

    type netent is                                          -- winsock2.h:171
        record
            n_name    : Win32.PSTR;                              -- winsock2.h:172
            n_aliases : PPCHAR;                             -- winsock2.h:173
            n_addrtype: Win32.SHORT;                              -- winsock2.h:174
            n_net     : u_long;                             -- winsock2.h:175
        end record;

    type SERVENT is                                         -- winsock2.h:178
        record
            s_name   : Win32.PSTR;                               -- winsock2.h:179
            s_aliases: PPCHAR;                              -- winsock2.h:180
            s_port   : Win32.SHORT;                               -- winsock2.h:181
            s_proto  : Win32.PSTR;                               -- winsock2.h:182
        end record;

    type PROTOENT is                                        -- winsock2.h:185
        record
            p_name   : Win32.PSTR;                               -- winsock2.h:186
            p_aliases: PPCHAR;                              -- winsock2.h:187
            p_proto  : Win32.SHORT;                               -- winsock2.h:188
        end record;

    type struct_anonymous1_t is                             -- winsock2.h:270
        record
            s_b1: u_char;                                   -- winsock2.h:270
            s_b2: u_char;                                   -- winsock2.h:270
            s_b3: u_char;                                   -- winsock2.h:270
            s_b4: u_char;                                   -- winsock2.h:270
        end record;

    type struct_anonymous2_t is                             -- winsock2.h:271
        record
            s_w1: u_short;                                  -- winsock2.h:271
            s_w2: u_short;                                  -- winsock2.h:271
        end record;

    type union_anonymous3_t_kind is (                       -- winsock2.h:273
        S_un_b_kind,
        S_un_w_kind,
        S_addr_kind
    );

    type union_anonymous3_t (Which: union_anonymous3_t_kind := S_un_b_kind) is
                                                            -- winsock2.h:273
        record
            case Which is
                when S_un_b_kind =>
                    S_un_b: struct_anonymous1_t;            -- winsock2.h:270
                when S_un_w_kind =>
                    S_un_w: struct_anonymous2_t;            -- winsock2.h:271
                when S_addr_kind =>
                    S_addr: u_long;                         -- winsock2.h:272
            end case;
        end record;

  pragma Convention(C_Pass_By_Copy, Union_Anonymous3_T);

    pragma Unchecked_Union(union_anonymous3_t);

    type IN_ADDR is                                         -- winsock2.h:268
        record
            S_un: union_anonymous3_t;                       -- winsock2.h:273
        end record;

    type SOCKADDR_IN is                                     -- winsock2.h:318
        record
            sin_family: Win32.SHORT;                        -- winsock2.h:319
            sin_port  : u_short;                            -- winsock2.h:320
            sin_addr  : IN_ADDR;                            -- winsock2.h:321
            sin_zero  : Win32.CHAR_Array(0..7);             -- winsock2.h:322
        end record;

    type WSADATA is                                         -- winsock2.h:328
        record
            wVersion      : Win32.WORD;                     -- winsock2.h:329
            wHighVersion  : Win32.WORD;                     -- winsock2.h:330
            szDescription : Win32.CHAR_Array(0..WSADESCRIPTION_LEN);
                                                            -- winsock2.h:331
            szSystemStatus: Win32.CHAR_Array(0..WSASYS_STATUS_LEN);
                                                            -- winsock2.h:332
            iMaxSockets   : Win32.USHORT;                   -- winsock2.h:333
            iMaxUdpDg     : Win32.USHORT;                   -- winsock2.h:334
            lpVendorInfo  : Win32.PSTR;                     -- winsock2.h:335
        end record;

    type ip_mreq is                                         -- winsock2.h:357
        record
            imr_multiaddr: IN_ADDR;                         -- winsock2.h:358
            imr_interface: IN_ADDR;                         -- winsock2.h:359
        end record;

     type SOCKADDR is                                        -- winsock2.h:473
        record
            sa_family: u_short;                             -- winsock2.h:474
            sa_data  : Win32.CHAR_Array(0..13);             -- winsock2.h:475
        end record;

    type sockproto is                                       -- winsock2.h:482
        record
            sp_family  : u_short;                           -- winsock2.h:483
            sp_protocol: u_short;                           -- winsock2.h:484
        end record;

    type LINGER is                                          -- winsock2.h:515
        record
            l_onoff : u_short;                              -- winsock2.h:516
            l_linger: u_short;                              -- winsock2.h:517
        end record;

    -- WinSock 2 extension -- new error codes and type definition

    subtype WSAEVENT is Win32.Winnt.HANDLE;
    type OVERLAPPED is
        record
            Internal    : Win32.DWORD;
            InternalHigh: Win32.DWORD;
            Offset      : Win32.DWORD;
            OffsetHigh  : Win32.DWORD;
            hEvent      : WSAEVENT;
        end record;

    subtype LPWSAEVENT is Win32.Windef.LPHANDLE;
    subtype WSAOVERLAPPED is OVERLAPPED;
    type LPWSAOVERLAPPED is access all WSAOVERLAPPED;

    WSA_IO_PENDING             : constant := 997;
    WSA_IO_INCOMPLETE          : constant := 996;
    WSA_INVALID_HANDLE         : constant := 6;
    WSA_INVALID_PARAMETER      : constant := 87;
    WSA_NOT_ENOUGH_MEMORY      : constant := 8;
    WSA_OPERATION_ABORTED      : constant := 995;

    WSA_INVALID_EVENT          : constant WSAEVENT := System.Null_Address;
    WSA_MAXIMUM_WAIT_EVENTS    : constant := 64;
    WSA_WAIT_FAILED            : constant := 16#ffffffff#;
    WSA_WAIT_EVENT_0           : constant := 16#0#;
    WSA_WAIT_IO_COMPLETION     : constant := 16#c0#;
    WSA_WAIT_TIMEOUT           : constant := 16#102#;
    WSA_INFINITE               : constant := 16#ffffffff#;

    type WSABUF is
        record
            len     : u_long;          -- the length of the buffer
            buf     : Win32.PSTR;      -- the pointer to the buffer
        end record;
    type LPWSABUF is access all WSABUF;

    type flowspec is
        record
            TokenRate           :   u_long;             -- In Bytes/sec
            TokenBucketSize     :   u_long;             -- in Bytes
            PeakBandwidth       :   u_long;             -- In Bytes/sec
            Latency             :   u_long;             -- In microseconds
            DelayVariation      :   u_long;             -- In microseconds
            ServiceType         :   u_long;
            MaxSduSize          :   u_long;             -- In Bytes */
            MinimumPolicedSize  :   u_long;             -- In Bytes */
        end record;

    type LPFLOWSPEC is access all flowspec;

    type QOS is
        record
            SendingFlowspec     :   flowspec;           -- the flow spec for data sending
            ReceivingFlowspec   :   flowspec;           -- the flow spec for data receiving
            ProviderSpecific    :   WSABUF;             -- additional provider specific stuff
        end record;

    type  PQOS is access all QOS;

    -- manifest constants for return values of the condition function

    CF_ACCEPT                   : constant := 16#0#;
    CF_REJECT                   : constant := 16#1#;
    CF_DEFER                    : constant := 16#2#;

    -- manifest constants for shutdown()

    SD_RECEIVE                  : constant := 16#00#;
    SD_SEND                     : constant := 16#1#;
    SD_BOTH                     : constant := 16#2#;

    -- data type and manifest constants for socket groups

    subtype GROUP is u_int;

    SG_UNCONSTRAINED_GROUP      : constant := 16#1#;
    SG_CONSTRAINED_GROUP        : constant := 16#2#;

    -- data type for WSAEnumNetworkEvents()
    type errorcodes is  array(1..FD_MAX_EVENTS) of Win32.INT;

    type WSANETWORKEVENTS is
        record
            lNetworkEvents      :   Win32.LONG;
            iErrorCode          :   errorcodes;
        end record;

    type LPWSANETWORKEVENTS is access all WSANETWORKEVENTS;

    -- WSAPROTOCOL_INFO structure and associated

    type datacodes is array(0..7) of u_char;

    type GUID is
        record
            Data1       :   u_long;
            Data2       :   u_short;
            Data3       :   u_short;
            Data4       :   datacodes;
        end record;

    type LPGUID is access all GUID;

    MAX_PROTOCOL_CHAIN      : constant := 7;
    BASE_PROTOCOL           : constant := 1;
    LAYERED_PROTOCOL        : constant := 0;

    type chainentrytype is array (0..MAX_PROTOCOL_CHAIN-1) of Win32.DWORD;
    type WSAPROTOCOLCHAIN is
        record
            ChainLen        :   Win32.INT;
            ChainEntries    :   chainentrytype;
        end record;

    type LPWSAPROTOCOLCHAIN is access all WSAPROTOCOLCHAIN;

    WSAPROTOCOL_LEN         : constant := 255;

    type protocols is array(0..WSAPROTOCOL_LEN) of CHAR;

    type WSAPROTOCOL_INFO is
        record
            dwServiceFlags1     :   Win32.DWORD;
            dwServiceFlags2     :   Win32.DWORD;
            dwServiceFlags3     :   Win32.DWORD;
            dwServiceFlags4     :   Win32.DWORD;
            dwProviderFlags     :   Win32.DWORD;
            ProviderId          :   GUID;
            dwCatalogEntryId    :   Win32.DWORD;
            ProtocolChain       :   WSAPROTOCOLCHAIN;
            iVersion            :   Win32.INT;
            iAddressFamily      :   Win32.INT;
            iMaxSockAddr        :   Win32.INT;
            iMinSockAddr        :   Win32.INT;
            iSocketType         :   Win32.INT;
            iProtocol           :   Win32.INT;
            iProtocolMaxOffset  :   Win32.INT;
            iNetworkByteOrder   :   Win32.INT;
            iSecurityScheme     :   Win32.INT;
            dwMessageSize       :   Win32.DWORD;
            dwProviderReserved  :   Win32.DWORD;
            szProtocol          :   protocols;
        end record;

    type LPWSAPROTOCOL_INFO is access all WSAPROTOCOL_INFO;

    -- Flag bit definitions for dwProviderFlags
    PFL_MULTIPLE_PROTO_ENTRIES  : constant := 16#1#;
    PFL_RECOMMENDED_PROTO_ENTRY : constant := 16#2#;
    PFL_HIDDEN                  : constant := 16#4#;
    PFL_MATCHES_PROTOCOL_ZERO   : constant := 16#8#;

    -- Flag bit definitions for dwServiceFlags1
    XP1_CONNECTIONLESS              : constant := 16#1#;
    XP1_GUARANTEED_DELIVERY         : constant := 16#2#;
    XP1_GUARANTEED_ORDER            : constant := 16#4#;
    XP1_MESSAGE_ORIENTED            : constant := 16#8#;
    XP1_PSEUDO_STREAM               : constant := 16#10#;
    XP1_GRACEFUL_CLOSE              : constant := 16#20#;
    XP1_EXPEDITED_DATA              : constant := 16#40#;
    XP1_CONNECT_DATA                : constant := 16#80#;
    XP1_DISCONNECT_DATA             : constant := 16#100#;
    XP1_SUPPORT_BROADCAST           : constant := 16#200#;
    XP1_SUPPORT_MULTIPOINT          : constant := 16#400#;
    XP1_MULTIPOINT_CONTROL_PLANE    : constant := 16#800#;
    XP1_MULTIPOINT_DATA_PLANE       : constant := 16#1000#;
    XP1_QOS_SUPPORTED               : constant := 16#2000#;
    XP1_INTERRUPT                   : constant := 16#4000#;
    XP1_UNI_SEND                    : constant := 16#8000#;
    XP1_UNI_RECV                    : constant := 16#10000#;
    XP1_IFS_HANDLES                 : constant := 16#20000#;
    XP1_PARTIAL_MESSAGE             : constant := 16#40000#;

    BIGENDIAN                       : constant := 16#0#;
    LITTLEENDIAN                    : constant := 16#1#;

    SECURITY_PROTOCOL_NONE          : constant := 16#0#;

    -- manifest constants for WSAJoinLeaf()
    JL_SENDER_ONLY                  : constant := 16#01#;
    JL_RECEIVER_ONLY                : constant := 16#2#;
    JL_BOTH                         : constant := 16#4#;

    -- manifest constants for WSASocket()
    WSA_FLAG_OVERLAPPED             : constant := 16#1#;
    WSA_FLAG_MULTIPOINT_C_ROOT      : constant := 16#2#;
    WSA_FLAG_MULTIPOINT_C_LEAF      : constant := 16#4#;
    WSA_FLAG_MULTIPOINT_D_ROOT      : constant := 16#8#;
    WSA_FLAG_MULTIPOINT_D_LEAF      : constant := 16#10#;

    -- manifest constants for WSAIoctl()
    IOC_UNIX                        : constant := 16#0#;
    IOC_WS2                         : constant := 16#8000000#;
    IOC_PROTOCOL                    : constant := 16#10000000#;
    IOC_VENDOR                      : constant := 16#18000000#;

    function WSAIO(x,y : int) return int;                  --(IOC_VOID|(x)|(y))
    function WSAIOR(x,y : int) return int;                 --(IOC_OUT|(x)|(y))
    function WSAIOW(x,y : int) return int;                 --(IOC_IN|(x)|(y))
    function WSAIORW(x,y : int) return int;                --(IOC_INOUT|(x)|(y))

    SIO_ASSOCIATE_HANDLE            : constant := 16#88000001#;
    SIO_ENABLE_CIRCULAR_QUEUEING    : constant := 16#28000002#;
    SIO_FIND_ROUTE                  : constant := 16#48000003#;
    SIO_FLUSH                       : constant := 16#28000004#;
    SIO_GET_BROADCAST_ADDRESS       : constant := 16#48000005#;
    SIO_GET_EXTENSION_FUNCTION_POINTER  : constant := 16#c8000006#;
    SIO_GET_QOS                     : constant := 16#c8000007#;
    SIO_GET_GROUP_QOS               : constant := 16#c8000008#;
    SIO_MULTIPOINT_LOOPBACK         : constant := 16#88000009#;
    SIO_MULTICAST_SCOPE             : constant := 16#8800000a#;
    SIO_SET_QOS                     : constant := 16#8800000b#;
    SIO_SET_GROUP_QOS               : constant := 16#8800000c#;
    SIO_TRANSLATE_HANDLE            : constant := 16#c800000d#;
    SIO_ROUTING_INTERFACE_QUERY     : constant := 16#c8000014#;
    SIO_ROUTING_INTERFACE_CHANGE    : constant := 16#88000015#;
    SIO_ADDRESS_LIST_QUERY          : constant := 16#48000016#;
    SIO_ADDRESS_LIST_CHANGE         : constant := 16#28000017#;
    SIO_QUERY_TARGET_PNP_HANDLE     : constant := 16#48000018#;

    -- manifest constants for SIO_TRANSLATE_HANDLE ioctl
    TH_NETDEV                       : constant := 16#1#;
    TH_TAPI                         : constant := 16#2#;

    --Manifest constants and type definitions related to name resolution
    type BLOB is
        record
            cbSize      :   u_long;
            pBlobData   :   PBYTE;
        end record;
    type PBLOB is access all BLOB;

    --Service Install Flags
    SERVICE_MULTIPLE                : constant := 16#1#;

    --Name Spaces
    NS_ALL                          : constant := 0;
    NS_SAP                          : constant := 1;
    NS_NDS                          : constant := 2;
    NS_PEER_BROWSE                  : constant := 3;
    NS_TCPIP_LOCAL                  : constant := 10;
    NS_TCPIP_HOSTS                  : constant := 11;
    NS_DNS                          : constant := 12;
    NS_NETBT                        : constant := 13;
    NS_WINS                         : constant := 14;
    NS_NBP                          : constant := 20;
    NS_MS                           : constant := 30;
    NS_STDA                         : constant := 31;
    NS_NTDS                         : constant := 32;
    NS_X500                         : constant := 40;
    NS_NIS                          : constant := 41;
    NS_NISPLUS                      : constant := 42;
    NS_WRQ                          : constant := 50;

    RES_UNUSED_1                    : constant := 16#1#;
    RES_FLUSH_CACHE                 : constant := 16#2#;
    RES_SERVICE                     : constant := 16#4#;

    -- Well known value names for Service Types

    SERVICE_TYPE_VALUE_IPXPORTA     : constant interfaces.c.char_array
                                := "IpxSocket" & interfaces.c.Nul;
    SERVICE_TYPE_VALUE_SAPIDA      : constant interfaces.c.char_array
                                := "SapId" & interfaces.c.Nul;
    SERVICE_TYPE_VALUE_TCPPORTA   : constant interfaces.c.char_array
                                := "TcpPort" & interfaces.c.Nul;

    SERVICE_TYPE_VALUE_UDPPORTA    : constant interfaces.c.char_array
                                := "UdpPort" & interfaces.c.Nul;

    SERVICE_TYPE_VALUE_OBJECTIDA   : constant interfaces.c.char_array
                                := "ObjectId" & interfaces.c.Nul;

     SERVICE_TYPE_VALUE_SAPID       : constant interfaces.c.char_array(0..5) := SERVICE_TYPE_VALUE_SAPIDA;
     SERVICE_TYPE_VALUE_TCPPORT     : constant interfaces.c.char_array(0..7) := SERVICE_TYPE_VALUE_TCPPORTA;
     SERVICE_TYPE_VALUE_UDPPORT     : constant interfaces.c.char_array(0..7) := SERVICE_TYPE_VALUE_UDPPORTA;
     SERVICE_TYPE_VALUE_OBJECTID    : constant interfaces.c.char_array(0..8) := SERVICE_TYPE_VALUE_OBJECTIDA;

     -- SockAddr Information
     type SOCKET_ADDRESS is
         record
             lpSockaddr         : PSOCKADDR;
             iSockaddrLength    : Win32.INT;
         end record;

    type LPSOCKET_ADDRESS is access all SOCKET_ADDRESS;

    --CSAddr Information
    type CSADDR_INFO is
        record
            LocalAddr       : SOCKET_ADDRESS;
            RemoteAddr      : SOCKET_ADDRESS;
            iSocketType     : Win32.INT;
            iProtocol       : Win32.INT;
        end record;
    type LPCSADDR_INFO is access all CSADDR_INFO;

    type Addresses is array(0..0) of SOCKET_ADDRESS;
    -- Address list returned via SIO_ADDRESS_LIST_QUERY
    type SOCKET_ADDRESS_LIST is
        record
            iAddressCount       : Win32.INT;
            Address             : Addresses;
        end record;

    type LPSOCKET_ADDRESS_LIST is access all SOCKET_ADDRESS_LIST;

    -- Address Family/Protocol Tuples
    type AFPROTOCOLS is
        record
            iAddressFamily      : Win32.INT;
            iProtocol           : Win32.INT;
        end record;

    type PAFPROTOCOLS is access all AFPROTOCOLS;
    subtype LPAFPROTOCOLS is PAFPROTOCOLS;

    -- Client Query API Typedefs
    type WSAEcomparator is (COMP_EQUAL,COMP_NOTLESS);
    for WSAECOMPARATOR use (COMP_EQUAL=> 0,COMP_NOTLESS =>1);

    type PWSAECOMPARATOR is access all WSAECOMPARATOR;
    subtype LPWSAECOMPARATOR is PWSAECOMPARATOR;
--{
--   COMP_EQUAL = 0,
--    COMP_NOTLESS
--} WSAECOMPARATOR, *PWSAECOMPARATOR, *LPWSAECOMPARATOR;

    type WSAVersion is
        record
            dwVersion           : Win32.DWORD;
            ecHow               : WSAECOMPARATOR;
        end record;

    type PWSAVERSION is access all WSAVERSION;
    subtype LPWSAVERSION is PWSAVERSION;

type WSAQuerySet is
    record
        dwSize                  :   Win32.DWORD;
        lpszServiceInstanceName :   Win32.LPSTR;
        lpServiceClassId        :   LPGUID;
        lpVersion               :   LPWSAVERSION;
        lpszComment             :   Win32.LPSTR;
        dwNameSpace             :   Win32.DWORD;
        lpNSProviderId          :   LPGUID;
        lpszContext             :   Win32.LPSTR;
        dwNumberOfProtocols     :   Win32.DWORD;
        lpafpProtocols          :   LPAFPROTOCOLS;
        lpszQueryString         :   Win32.LPSTR;
        dwNumberOfCsAddrs       :   LPAFPROTOCOLS;
        lpcsaBuffer             :   LPCSADDR_INFO;
        dwOutputFlags           :   Win32.DWORD;
        lpBlob                  :   PBLOB;
    end record;

type PWSAQUERYSET is access all WSAQUERYSET;
subtype LPWSAQUERYSET is PWSAQUERYSET;

LUP_DEEP                    : constant := 16#0001#;
LUP_CONTAINERS              : constant := 16#2#;
LUP_NOCONTAINERS            : constant := 16#4#;
LUP_NEAREST                 : constant := 16#8#;
LUP_RETURN_NAME             : constant := 16#10#;
LUP_RETURN_TYPE             : constant := 16#20#;
LUP_RETURN_VERSION          : constant := 16#40#;
LUP_RETURN_COMMENT          : constant := 16#80#;
LUP_RETURN_ADDR             : constant := 16#100#;
LUP_RETURN_BLOB             : constant := 16#200#;
LUP_RETURN_ALIASES          : constant := 16#400#;
LUP_RETURN_QUERY_STRING     : constant := 16#800#;
LUP_RETURN_ALL              : constant := 16#FF0#;
LUP_RES_SERVICE             : constant := 16#8000#;
LUP_FLUSHCACHE              : constant := 16#1000#;
LUP_FLUSHPREVIOUS           : constant := 16#2000#;

RESULT_IS_ALIAS             : constant := 16#1#;

-- Service Address Registration and Deregistration Data Types.

type WSAESETSERVICEOP is  (     RNRSERVICE_REGISTER,
                                RNRSERVICE_DEREGISTER,
                                RNRSERVICE_DELETE);
for WSAESETSERVICEOP use  (     RNRSERVICE_REGISTER => 0,
                                RNRSERVICE_DEREGISTER => 1,
                                RNRSERVICE_DELETE => 2);

type PWSAESETSERVICEOP is access all WSAESETSERVICEOP;
subtype LPWSAESETSERVICEOP is PWSAESETSERVICEOP;

-- Service Installation/Removal Data Types.

type WSANSClassInfo is
    record
        lpszName        :   Win32.LPSTR;
        dwNameSpace     :   Win32.DWORD;
        dwValueType     :   Win32.DWORD;
        dwValueSize     :   Win32.DWORD;
        lpValue         :   LPVOID;
    end record;

type PWSANSCLASSINFO is access all WSANSCLASSINFO;
subtype LPWSANSCLASSINFO is WSANSCLASSINFO;

type WSAServiceClassInfo is
    record
        lpServiceClassId    :   LPGUID;
        lpszServiceClassName:   Win32.LPSTR;
        dwCount             :   Win32.DWORD;
        lpClassInfos        :   LPWSANSCLASSINFO;
    end record;

type PWSASERVICECLASSINFO is access all WSASERVICECLASSINFO;
subtype LPWSASERVICECLASSINFO is PWSASERVICECLASSINFO;

type WSANAMESPACE_INFO is
    record
        NSProviderId        :   GUID;
        dwNameSpace         :   Win32.DWORD;
        fActive             :   Win32.BOOL;
        dwVersion           :   Win32.DWORD;
        lpszIdentifier      :   Win32.LPSTR;
    end record;

type PWSANAMESPACE_INFO is access all WSANAMESPACE_INFO;
subtype LPWSANAMESPACE_INFO is PWSANAMESPACE_INFO;

    function WSAFDIsSet(
                fd : SOCKET;
                set: access FD_SET)
               return Win32.INT;                            -- winsock2.h:68

    procedure FD_CLR(fd : SOCKET;
                     set: access FD_SET);                   -- winsock2.h:75

    procedure FD_SET_PROC(fd : SOCKET;
                          set: access FD_SET);              -- winsock2.h:90

--    procedure FD_ZERO(set : access FD_SET);               -- winsock2.h:95

    function FD_ISSET(fd : SOCKET;
                      set: access FD_SET)                   -- winsock2.h:97
                      return Win32.INT
                      renames WSAFDIsSet;

    function timerisset(tvp: access TIMEVAL) return Win32.BOOL;
                                                            -- winsock2.h:112

    type LPCMPFN is access function (left, right: Win32.LONG) return Boolean;

    function timercmp(tvp: access TIMEVAL;
                      uvp: access TIMEVAL;
                      cmp: LPCMPFN)
                      return Win32.BOOL;                    -- winsock2.h:113
    pragma Convention(Stdcall, LPCMPFN);

    procedure timerclear(tvp: access TIMEVAL);              -- winsock2.h:116

    function FIONREAD return Win32.LONG;                    -- winsock2.h:141
    function FIONBIO return Win32.LONG;                     -- winsock2.h:142
    function FIOASYNC return Win32.LONG;                    -- winsock2.h:143
    function SIOCSHIWAT return Win32.LONG;                  -- winsock2.h:146
    function SIOCGHIWAT return Win32.LONG;                  -- winsock2.h:147
    function SIOCSLOWAT return Win32.LONG;                  -- winsock2.h:148
    function SIOCGLOWAT return Win32.LONG;                  -- winsock2.h:149
    function SIOCATMARK return Win32.LONG;                  -- winsock2.h:150

    function IN_CLASSA(i: Win32.LONG) return Win32.BOOL;    -- winsock2.h:293

    function IN_CLASSB(i: Win32.LONG) return Win32.BOOL;    -- winsock2.h:299

    function IN_CLASSC(i: Win32.LONG) return Win32.BOOL;    -- winsock2.h:305

    function IN_CLASSD(i: Win32.LONG) return Win32.BOOL;    -- winsock2.h:305

    function c_accept(
                s      : SOCKET;
                addr   : access SOCKADDR;
                addrlen: access Win32.INT)
               return SOCKET;                               -- winsock2.h:702

    function bind(
                s      : SOCKET;
                addr   : ac_SOCKADDR_t;
                namelen: Win32.INT)
               return Win32.INT;                            -- winsock2.h:705

    function closesocket(
                s: SOCKET)
               return Win32.INT;                            -- winsock2.h:707

    function connect(
                s      : SOCKET;
                name   : ac_SOCKADDR_t;
                namelen: Win32.INT)
               return Win32.INT;                            -- winsock2.h:709

    function ioctlsocket(
                s   : SOCKET;
                cmd : Win32.LONG;
                argp: access Win32.ULONG)
               return Win32.INT;                            -- winsock2.h:711

    function getpeername(
                s      : SOCKET;
                name   : access SOCKADDR;
                namelen: access Win32.INT)
               return Win32.INT;                            -- winsock2.h:713

    function getsockname(
                s      : SOCKET;
                name   : access SOCKADDR;
                namelen: access Win32.INT)
               return Win32.INT;                            -- winsock2.h:716

    function getsockopt(
                s      : SOCKET;
                level  : Win32.INT;
                optname: Win32.INT;
                optval : Win32.PSTR;
                optlen : access Win32.INT)
               return Win32.INT;                            -- winsock2.h:719

    function htonl(
                hostlong: u_long)
               return u_long;                               -- winsock2.h:722

    function htons(
                hostshort: u_short)
               return u_short;                              -- winsock2.h:724

    function inet_addr(
                cp: Win32.PCSTR)
               return Win32.ULONG;                          -- winsock2.h:726

    function inet_ntoa(
                c_in: IN_ADDR)
               return Win32.PSTR;                           -- winsock2.h:728

    function listen(
                s      : SOCKET;
                backlog: Win32.INT)
               return Win32.INT;                            -- winsock2.h:730

    function ntohl(
                netlong: u_long)
               return u_long;                               -- winsock2.h:732

    function ntohs(
                netshort: u_short)
               return u_short;                              -- winsock2.h:734

    function recv(
                s    : SOCKET;
                buf  : Win32.PSTR;
                len  : Win32.INT;
                flags: Win32.INT)
               return Win32.INT;                            -- winsock2.h:736

    function recvfrom(
                s      : SOCKET;
                buf    : Win32.PSTR;
                len    : Win32.INT;
                flags  : Win32.INT;
                from   : access SOCKADDR;
                fromlen: access Win32.INT)
               return Win32.INT;                            -- winsock2.h:738

    function c_select(
                nfds     : Win32.INT;
                readfds  : access FD_SET;
                writefds : access FD_SET;
                exceptfds: access FD_SET;
                timeout  : ac_TIMEVAL_t)
               return Win32.INT;                            -- winsock2.h:741

    function send(
                s    : SOCKET;
                buf  : Win32.PCSTR;
                len  : Win32.INT;
                flags: Win32.INT)
               return Win32.INT;                            -- winsock2.h:744

    function sendto(
                s    : SOCKET;
                buf  : Win32.PCSTR;
                len  : Win32.INT;
                flags: Win32.INT;
                to   : ac_SOCKADDR_t;
                tolen: Win32.INT)
               return Win32.INT;                            -- winsock2.h:746

    function setsockopt(
                s      : SOCKET;
                level  : Win32.INT;
                optname: Win32.INT;
                optval : Win32.PCSTR;
                optlen : Win32.INT)
               return Win32.INT;                            -- winsock2.h:749

    function shutdown(
                s  : SOCKET;
                how: Win32.INT)
               return Win32.INT;                            -- winsock2.h:752

    function socket_func(
                af      : Win32.INT;
                c_type  : Win32.INT;
                protocol: Win32.INT)
               return SOCKET;                               -- winsock2.h:754

    function gethostbyaddr(
                addr  : Win32.PCSTR;
                len   : Win32.INT;
                c_type: Win32.INT)
               return PHOSTENT;                             -- winsock2.h:758

    function gethostbyname(
                name: Win32.PCSTR)
               return PHOSTENT;                             -- winsock2.h:761

    function gethostname(
                name   : Win32.PSTR;
                namelen: Win32.INT)
               return Win32.INT;                            -- winsock2.h:763

    function getservbyport(
                port : Win32.INT;
                proto: Win32.PCSTR)
               return PSERVENT;                             -- winsock2.h:765

    function getservbyname(
                name : Win32.PCSTR;
                proto: Win32.PCSTR)
               return PSERVENT;                             -- winsock2.h:767

    function getprotobynumber(
                proto: Win32.INT)
               return PPROTOENT;                            -- winsock2.h:770

    function getprotobyname(
                name: Win32.PCSTR)
               return PPROTOENT;                            -- winsock2.h:772

    function WSAStartup(
                wVersionRequested: Win32.WORD;
                lpWSAData        : Win32.Winsock2.LPWSADATA)
               return Win32.INT;                            -- winsock2.h:776

    function WSACleanup return Win32.INT;                   -- winsock2.h:778

    procedure WSASetLastError(
                iError: Win32.INT);                         -- winsock2.h:780

    function WSAGetLastError return Win32.INT;              -- winsock2.h:782

    function h_errno return Win32.INT                       -- winsock2.h:629
                renames WSAGetLastError;

    function WSAIsBlocking return Win32.BOOL;               -- winsock2.h:784

    function WSAUnhookBlockingHook return Win32.INT;        -- winsock2.h:786

    function WSASetBlockingHook(
                lpBlockFunc: Win32.Windef.FARPROC)
               return Win32.Windef.FARPROC;                 -- winsock2.h:788

    function WSACancelBlockingCall return Win32.INT;        -- winsock2.h:790

    function WSAAsyncGetServByName(
                hWnd  : Win32.Windef.HWND;
                wMsg  : u_int;
                name  : Win32.PCSTR;
                proto : Win32.PCSTR;
                buf   : Win32.PSTR;
                buflen: Win32.INT)
               return Win32.Winnt.HANDLE;                   -- winsock2.h:792

    function WSAAsyncGetServByPort(
                hWnd  : Win32.Windef.HWND;
                wMsg  : u_int;
                port  : Win32.INT;
                proto : Win32.PCSTR;
                buf   : Win32.PSTR;
                buflen: Win32.INT)
               return Win32.Winnt.HANDLE;                   -- winsock2.h:797

    function WSAAsyncGetProtoByName(
                hWnd  : Win32.Windef.HWND;
                wMsg  : u_int;
                name  : Win32.PCSTR;
                buf   : Win32.PSTR;
                buflen: Win32.INT)
               return Win32.Winnt.HANDLE;                   -- winsock2.h:801

    function WSAAsyncGetProtoByNumber(
                hWnd  : Win32.Windef.HWND;
                wMsg  : u_int;
                number: Win32.INT;
                buf   : Win32.PSTR;
                buflen: Win32.INT)
               return Win32.Winnt.HANDLE;                   -- winsock2.h:805

    function WSAAsyncGetHostByName(
                hWnd  : Win32.Windef.HWND;
                wMsg  : u_int;
                name  : Win32.PCSTR;
                buf   : Win32.PSTR;
                buflen: Win32.INT)
               return Win32.Winnt.HANDLE;                   -- winsock2.h:809

    function WSAAsyncGetHostByAddr(
                hWnd  : Win32.Windef.HWND;
                wMsg  : u_int;
                addr  : Win32.PCSTR;
                len   : Win32.INT;
                c_type: Win32.INT;
                buf   : Win32.PSTR;
                buflen: Win32.INT)
               return Win32.Winnt.HANDLE;                   -- winsock2.h:813

    function WSACancelAsyncRequest(
                hAsyncTaskHandle: Win32.Winnt.HANDLE)
               return Win32.INT;                            -- winsock2.h:817

    function WSAAsyncSelect(
                s     : SOCKET;
                hWnd  : Win32.Windef.HWND;
                wMsg  : u_int;
                lEvent: Win32.LONG)
               return Win32.INT;                            -- winsock2.h:819

    function WSARecvEx(
                s    : SOCKET;
                buf  : Win32.PSTR;
                len  : Win32.INT;
                flags: access Win32.INT)
               return Win32.INT;                            -- winsock2.h:822

    --WinSock 2 extensions -- data types for the condition function in

    type LPCONDITIONPROC is access function(lpCallerId      : LPWSABUF;
                                            lpCallerData    : LPWSABUF;
                                            lpSQOS          : access QOS;
                                            lpGQOS          : access QOS;
                                            lpCalleeId      : LPWSABUF;
                                            lpCalleeData    : LPWSABUF;
                                            g               : access GROUP;
                                            dwCallbackData  : Win32.DWORD) return Win32.INT;

    pragma Convention(Stdcall, LPCONDITIONPROC);

    type LPWSAOVERLAPPED_COMPLETION_ROUTINE is access procedure
                            (   dwError         : IN Win32.DWORD;
                                cbTransferred   : IN Win32.DWORD;
                                lpOverlapped    : IN LPWSAOVERLAPPED;
                                dwFlags         : IN Win32.DWORD);

    pragma Convention(Stdcall, LPWSAOVERLAPPED_COMPLETION_ROUTINE);

    function WSAAccept( s       : SOCKET;
                        addr    : access sockaddr;
                        addrlen : access Win32.INT;
                        lpfnCondition   : IN LPCONDITIONPROC;
                        dwCallbackData  : IN Win32.DWORD ) return SOCKET;

    function WSACloseEvent(hEvent : IN WSAEVENT ) return Win32.BOOL;

    function WSAConnect(    s           : SOCKET;
                            name        : lpsockaddr;
                            namelen     : int;
                            lpCallerData: LPWSABUF;
                            lpCalleeData: access WSABUF;
                            lpSQOS      : PQOS;
                            lpGQOS      : PQOS) return Win32.INT;

    function WSACreateEvent return WSAEVENT;

    function WSADuplicateSocket(s               : SOCKET;
                                dwProcessId     : Win32.DWORD;
                                lpProtocolInfo  : LPWSAPROTOCOL_INFO) return int;

    function WSAEnumNetworkEvents(  s               : SOCKET;
                                    hEventObject    : WSAEVENT;
                                    lpNetworkEvents : LPWSANETWORKEVENTS) return int;

    function WSAEnumProtocols(  lpiProtocols    : access Win32.INT;
                                lpProtocolBuffer: LPWSAPROTOCOL_INFO;
                                lpdwBufferLength: access Win32.DWORD)return int;

    function WSAEventSelect(    s               : SOCKET;
                                hEventObject    : WSAEVENT;
                                lNetworkEvents  : long   ) return int;

    function WSAGetOverlappedResult(    s               : SOCKET;
                        lpOverlapped    : LPWSAOVERLAPPED;
                        lpcbTransfer    : access Win32.DWORD;
                        fWait           : Win32.BOOL;
                        lpdwFlags       : access Win32.DWORD) return Win32.BOOL;

    function WSAGetQOSByName(   s           : SOCKET;
                    lpQOSName   : LPWSABUF;
                    lpQOS       : PQOS) return Win32.BOOL;

    function WSAHtonl(  s           : SOCKET;
                        hostlong    : u_long;
                        lpnetlong   : access u_long) return int;

    function WSAHtons(  s           : SOCKET;
                        hostshort   : u_short;
                        lpnetshort  : access u_short) return int;

    function WSAIoctl(  s               : SOCKET;
                        dwIoControlCode : Win32.DWORD;
                        lpvInBuffer     : LPVOID;
                        cbInBuffer      : Win32.DWORD;
                        lpvOutBuffer    : LPVOID;
                        cbOutBuffer     : Win32.DWORD;
                        lpcbBytesReturned: access Win32.DWORD;
                        lpOverlapped    : LPWSAOVERLAPPED;
                        lpCompletionRoutine: LPWSAOVERLAPPED_COMPLETION_ROUTINE ) return int;

    function WSAJoinLeaf(   s               : SOCKET;
                            name            : lpsockaddr;
                            namelen         : int;
                            lpCallerData    : LPWSABUF;
                            lpCalleeData    : LPWSABUF;
                            lpSQOS          : PQOS;
                            lpGQOS          : PQOS;
                            dwFlags         : Win32.DWORD) return SOCKET;

    function WSANtohl(  s           : SOCKET;
                        netlong     : u_long;
                        lphostlong  : access u_long) return int;

    function WSANtohs(  s           : SOCKET;
                        netshort    : u_short;
                        lphostshort : access u_short) return int;

    function WSARecv(   s                   : SOCKET;
                        lpBuffers           : LPWSABUF;
                        dwBufferCount       : Win32.DWORD;
                        lpNumberOfBytesRecvd: access Win32.DWORD;
                        lpFlags             : access Win32.DWORD;
                        lpOverlapped        : LPWSAOVERLAPPED;
                        lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE) return int;

    function WSARecvDisconnect( s                       : SOCKET;
                                lpInboundDisconnectData : LPWSABUF) return int;

    function WSARecvFrom(   s                       : SOCKET;
                            lpBuffers               : LPWSABUF;
                            dwBufferCount           : Win32.DWORD;
                            lpNumberOfBytesRecvd    : access Win32.DWORD;
                            lpFlags                 : access Win32.DWORD;
                            lpFrom                  : access sockaddr;
                            lpFromlen               : access int;
                            lpOverlapped            : LPWSAOVERLAPPED;
                            lpCompletionRoutine     : LPWSAOVERLAPPED_COMPLETION_ROUTINE )
                            return int;

    function WSAResetEvent( hEvent : WSAEVENT) return Win32.BOOL;

    function WSASend(   s                       : SOCKET;
                        lpBuffers               : LPWSABUF;
                        dwBufferCount           : Win32.DWORD;
                        lpNumberOfBytesSent     : access Win32.DWORD;
                        dwFlags                 :  Win32.DWORD;
                        lpOverlapped            : LPWSAOVERLAPPED;
                        lpCompletionRoutine     : LPWSAOVERLAPPED_COMPLETION_ROUTINE )
                        return int;

    function WSASendDisconnect( s                       : SOCKET;
                                lpOutboundDisconnectData: LPWSABUF) return int;

    function WSASendTo( s                   : SOCKET;
                        lpBuffers           : LPWSABUF;
                        dwBufferCount       : Win32.DWORD;
                        lpNumberOfBytesSent : access Win32.DWORD;
                        dwFlags             : Win32.DWORD;
                        lpTo                : LPSOCKADDR;
                        iTolen              : Win32.INT;
                        lpOverlapped        : LPWSAOVERLAPPED;
                        lpCompletionRoutine : LPWSAOVERLAPPED_COMPLETION_ROUTINE )
                        return int;

    function WSASetEvent( hEvent  : WSAEVENT ) return Win32.BOOL;

    function WSASocket( af              : Win32.INT;
                        c_type          : Win32.INT;
                        protocol        : Win32.INT;
                        lpProtocolInfo  : LPWSAPROTOCOL_INFO;
                        g               : GROUP;
                        dwFlags         : Win32.DWORD) return SOCKET;

    function WSAWaitForMultipleEvents(  cEvents     : Win32.DWORD;
                                        lphEvents   : LPWSAEVENT;
                                        fWaitAll    : Win32.BOOL;
                                        dwTimeout   : Win32.DWORD;
                                        fAlertable  : Win32.BOOL ) return Win32.DWORD;

    function WSAAddressToString(    lpsaAddress             : LPSOCKADDR;
                                    dwAddressLength         : Win32.DWORD;
                                    lpProtocolInfo          : LPWSAPROTOCOL_INFO;
                                    lpszAddressString       : Win32.PSTR;
                                    lpdwAddressStringLength : access Win32.DWORD  )
                                    return Win32.INT;

    function WSAStringToAddress(    AddressString       : Win32.LPSTR;
                                    AddressFamily       : Win32.INT;
                                    lpProtocolInfo      : LPWSAPROTOCOL_INFO;
                                    lpAddress           : LPSOCKADDR;
                                    lpAddressLength     : access Win32.INT)
                                    return Win32.INT;

-- Registration and Name Resolution API functions

    function WSALookupServiceBegin( lpqsRestrictions    : LPWSAQUERYSET;
                                    dwControlFlags      : Win32.DWORD;
                                    lphLookup           : Win32.Windef.LPHANDLE) return Win32.INT;

    function WSALookupServiceNext(  hLookup         : Win32.Winnt.HANDLE;
                                    dwControlFlags  : Win32.DWORD;
                                    lpdwBufferLength: access Win32.DWORD;
                                    lpqsResults     : LPWSAQUERYSET) return Win32.INT;

    function WSALookupServiceEnd(hLookup : Win32.Winnt.HANDLE ) return Win32.INT;

    function WSAInstallServiceClass(lpServiceClassInfo : LPWSASERVICECLASSINFO) return Win32.INT;

    function WSARemoveServiceClass(lpServiceClassId : LPGUID ) return Win32.INT;

    function WSAGetServiceClassInfo(    lpProviderId    : LPGUID;
                                        lpServiceClassId: LPGUID;
                                        lpdwBufSize     : access Win32.DWORD;
                                        lpServiceClassInfo : LPWSASERVICECLASSINFO )
                                        return Win32.INT;

    function WSAEnumNameSpaceProviders(lpdwBufferLength : access Win32.DWORD;
                                        lpnspBuffer     : LPWSANAMESPACE_INFO ) return Win32.INT;

    function WSAGetServiceClassNameByClassId(   lpServiceClassId    : LPGUID;
                                                lpszServiceClassName: Win32.PSTR;
                                                lpdwBufferLength    : access Win32.DWORD)
                                                return Win32.INT;

    function WSASetService( lpqsRegInfo     : LPWSAQUERYSET;
                            essoperation    : WSAESETSERVICEOP;
                            dwControlFlags  : Win32.DWORD) return Win32.INT;

    function WSAProviderConfigChange(   lpNotificationHandle    : Win32.Windef.LPHANDLE;
                            lpOverlapped            : LPWSAOVERLAPPED;
                            lpCompletionRoutine     : LPWSAOVERLAPPED_COMPLETION_ROUTINE)
                             return Win32.INT;

private

    pragma Convention(C, FD_SET);                           -- winsock2.h:59
    pragma Convention(C_Pass_By_Copy, TIMEVAL);                          -- winsock2.h:102
    pragma Convention(C_Pass_By_Copy, HOSTENT);                          -- winsock2.h:158
    pragma Convention(C_Pass_By_Copy, netent);                           -- winsock2.h:171
    pragma Convention(C_Pass_By_Copy, SERVENT);                          -- winsock2.h:178
    pragma Convention(C_Pass_By_Copy, PROTOENT);                         -- winsock2.h:185
    pragma Convention(C_Pass_By_Copy, struct_anonymous1_t);              -- winsock2.h:270
    pragma Convention(C_Pass_By_Copy, struct_anonymous2_t);              -- winsock2.h:271
    pragma Convention(C_Pass_By_Copy, IN_ADDR);                          -- winsock2.h:268
    pragma Convention(C_Pass_By_Copy, SOCKET_ADDRESS);                          -- winsock2.h:268
    pragma Convention(C_Pass_By_Copy, SOCKADDR_IN);                      -- winsock2.h:318
    pragma Convention(C_Pass_By_Copy, CSADDR_INFO);                      -- winsock2.h:318
    pragma Convention(C_Pass_By_Copy, SOCKET_ADDRESS_LIST);                      -- winsock2.h:318
    pragma Convention(C_Pass_By_Copy, AFPROTOCOLS);                      -- winsock2.h:318
    pragma Convention(C_Pass_By_Copy, WSAVERSION);                      -- winsock2.h:318
    pragma Convention(C_Pass_By_Copy, WSAQUERYSET);                      -- winsock2.h:318
    pragma Convention(C_Pass_By_Copy, WSANSCLASSINFO);                      -- winsock2.h:318
    pragma Convention(C_Pass_By_Copy, WSASERVICECLASSINFO);                      -- winsock2.h:318
    pragma Convention(C_Pass_By_Copy, WSANAMESPACE_INFO);                      -- winsock2.h:318
    pragma Convention(C, WSADATA);                          -- winsock2.h:328
    pragma Convention(C_Pass_By_Copy, ip_mreq);                          -- winsock2.h:357
    pragma Convention(C_Pass_By_Copy, SOCKADDR);                         -- winsock2.h:473
    pragma Convention(C_Pass_By_Copy, sockproto);                        -- winsock2.h:482
    pragma Convention(C_Pass_By_Copy, LINGER);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, OVERLAPPED);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, WSABUF);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, flowspec);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, QOS);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, WSANETWORKEVENTS);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, GUID);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, WSAPROTOCOLCHAIN);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, WSAPROTOCOL_INFO);                           -- winsock2.h:515
    pragma Convention(C_Pass_By_Copy, BLOB);                           -- winsock2.h:515
    pragma Import(Stdcall, WSAFDIsSet, "__WSAFDIsSet");           -- winsock2.h:68
    pragma Import(Stdcall, c_accept, "accept");                   -- winsock2.h:702
    pragma Import(Stdcall, bind, "bind");                         -- winsock2.h:705
    pragma Import(Stdcall, closesocket, "closesocket");           -- winsock2.h:707
    pragma Import(Stdcall, connect, "connect");                   -- winsock2.h:709
    pragma Import(Stdcall, ioctlsocket, "ioctlsocket");           -- winsock2.h:711
    pragma Import(Stdcall, getpeername, "getpeername");           -- winsock2.h:713
    pragma Import(Stdcall, getsockname, "getsockname");           -- winsock2.h:716
    pragma Import(Stdcall, getsockopt, "getsockopt");             -- winsock2.h:719
    pragma Import(Stdcall, htonl, "htonl");                       -- winsock2.h:722
    pragma Import(Stdcall, htons, "htons");                       -- winsock2.h:724
    pragma Import(Stdcall, inet_addr, "inet_addr");               -- winsock2.h:726
    pragma Import(Stdcall, inet_ntoa, "inet_ntoa");               -- winsock2.h:728
    pragma Import(Stdcall, listen, "listen");                     -- winsock2.h:730
    pragma Import(Stdcall, ntohl, "ntohl");                       -- winsock2.h:732
    pragma Import(Stdcall, ntohs, "ntohs");                       -- winsock2.h:734
    pragma Import(Stdcall, recv, "recv");                         -- winsock2.h:736
    pragma Import(Stdcall, recvfrom, "recvfrom");                 -- winsock2.h:738
    pragma Import(Stdcall, c_select, "select");                   -- winsock2.h:741
    pragma Import(Stdcall, send, "send");                         -- winsock2.h:744
    pragma Import(Stdcall, sendto, "sendto");                     -- winsock2.h:746
    pragma Import(Stdcall, setsockopt, "setsockopt");             -- winsock2.h:749
    pragma Import(Stdcall, shutdown, "shutdown");                 -- winsock2.h:752
    pragma Import(Stdcall, socket_func, "socket");                -- winsock2.h:754
    pragma Import(Stdcall, gethostbyaddr, "gethostbyaddr");       -- winsock2.h:758
    pragma Import(Stdcall, gethostbyname, "gethostbyname");       -- winsock2.h:761
    pragma Import(Stdcall, gethostname, "gethostname");           -- winsock2.h:763
    pragma Import(Stdcall, getservbyport, "getservbyport");       -- winsock2.h:765
    pragma Import(Stdcall, getservbyname, "getservbyname");       -- winsock2.h:767
    pragma Import(Stdcall, getprotobynumber, "getprotobynumber"); -- winsock2.h:770
    pragma Import(Stdcall, getprotobyname, "getprotobyname");     -- winsock2.h:772
    pragma Import(Stdcall, WSAStartup, "WSAStartup");             -- winsock2.h:776
    pragma Import(Stdcall, WSACleanup, "WSACleanup");             -- winsock2.h:778
    pragma Import(Stdcall, WSASetLastError, "WSASetLastError");   -- winsock2.h:780
    pragma Import(Stdcall, WSAGetLastError, "WSAGetLastError");   -- winsock2.h:782
    pragma Import(Stdcall, WSAIsBlocking, "WSAIsBlocking");       -- winsock2.h:784
    pragma Import(Stdcall, WSAUnhookBlockingHook, "WSAUnhookBlockingHook");
                                                            -- winsock2.h:786
    pragma Import(Stdcall, WSASetBlockingHook, "WSASetBlockingHook");
                                                            -- winsock2.h:788
    pragma Import(Stdcall, WSACancelBlockingCall, "WSACancelBlockingCall");
                                                            -- winsock2.h:790
    pragma Import(Stdcall, WSAAsyncGetServByName, "WSAAsyncGetServByName");
                                                            -- winsock2.h:792
    pragma Import(Stdcall, WSAAsyncGetServByPort, "WSAAsyncGetServByPort");
                                                            -- winsock2.h:797
    pragma Import(Stdcall, WSAAsyncGetProtoByName, "WSAAsyncGetProtoByName");
                                                            -- winsock2.h:801
    pragma Import(Stdcall, WSAAsyncGetProtoByNumber, "WSAAsyncGetProtoByNumber");
                                                            -- winsock2.h:805
    pragma Import(Stdcall, WSAAsyncGetHostByName, "WSAAsyncGetHostByName");
                                                            -- winsock2.h:809
    pragma Import(Stdcall, WSAAsyncGetHostByAddr, "WSAAsyncGetHostByAddr");
                                                            -- winsock2.h:813
    pragma Import(Stdcall, WSACancelAsyncRequest, "WSACancelAsyncRequest");
                                                            -- winsock2.h:817
    pragma Import(Stdcall, WSAAsyncSelect, "WSAAsyncSelect");     -- winsock2.h:819
    pragma Import(Stdcall, WSARecvEx, "WSARecvEx");               -- winsock2.h:822
    pragma Import(Stdcall, WSAAccept, "WSAAccept" );
    pragma Import(Stdcall, WSACloseEvent, "WSACloseEvent");
    pragma Import(Stdcall, WSAConnect, "WSAConnect" );
    pragma Import(Stdcall, WSACreateEvent, "WSACreateEvent");
    pragma Import(Stdcall, WSADuplicateSocket, "WSADuplicateSocketA" );
    pragma Import(Stdcall, WSAEnumNetworkEvents, "WSAEnumNetworkEvents");
    pragma Import(Stdcall, WSAEnumProtocols, "WSAEnumProtocolsA");
    pragma Import(Stdcall, WSAEventSelect, "WSAEventSelect" );
    pragma Import(Stdcall, WSAGetOverlappedResult, "WSAGetOverlappedResult" );
    pragma Import(Stdcall, WSAGetQOSByName, "WSAGetQOSByName");
    pragma Import(Stdcall, WSAHtonl, "WSAHtonl");
    pragma Import(Stdcall, WSAHtons, "WSAHtons");
    pragma Import(Stdcall, WSAIoctl, "WSAIoctl");
    pragma Import(Stdcall, WSAJoinLeaf, "WSAJoinLeaf" );
    pragma Import(Stdcall, WSANtohl, "WSANtohl");
    pragma Import(Stdcall, WSANtohs, "WSANtohs");
    pragma Import(Stdcall, WSARecv, "WSARecv" );
    pragma Import(Stdcall, WSARecvDisconnect, "WSARecvDisconnect");
    pragma Import(Stdcall, WSARecvFrom, "WSARecvFrom");
    pragma Import(Stdcall, WSAResetEvent, "WSAResetEvent");
    pragma Import(Stdcall, WSASend, "WSASend");
    pragma Import(Stdcall, WSASendDisconnect, "WSASendDisconnect");
    pragma Import(Stdcall, WSASendTo, "WSASendTo");
    pragma Import(Stdcall, WSASetEvent, "WSASetEvent");
    pragma Import(Stdcall, WSASocket, "WSASocketA");
    pragma Import(Stdcall, WSAWaitForMultipleEvents, "WSAWaitForMultipleEvents");
    pragma Import(Stdcall, WSAAddressToString, "WSAAddressToStringA" );
    pragma Import(Stdcall, WSAStringToAddress, "WSAStringToAddressA");
    pragma Import(Stdcall, WSALookupServiceBegin, "WSALookupServiceBeginA" );
    pragma Import(Stdcall, WSALookupServiceNext, "WSALookupServiceNextA");
    pragma Import(Stdcall, WSALookupServiceEnd, "WSALookupServiceEnd");
    pragma Import(Stdcall, WSAInstallServiceClass, "WSAInstallServiceClassA");
    pragma Import(Stdcall, WSARemoveServiceClass, "WSARemoveServiceClass");
    pragma Import(Stdcall, WSAGetServiceClassInfo, "WSAGetServiceClassInfoA");
    pragma Import(Stdcall, WSAEnumNameSpaceProviders, "WSAEnumNameSpaceProvidersA");
    pragma Import(Stdcall, WSAGetServiceClassNameByClassId, "WSAGetServiceClassNameByClassIdA");
    pragma Import(Stdcall, WSASetService, "WSASetServiceA");
    pragma Import(Stdcall, WSAProviderConfigChange, "WSAProviderConfigChange");

end Win32.Winsock2;
